package level;


import static org.lwjgl.opengl.GL11.GL_COMPILE;
import static org.lwjgl.opengl.GL11.GL_FLOAT;
import static org.lwjgl.opengl.GL11.GL_VERTEX_ARRAY;
import static org.lwjgl.opengl.GL11.glCallList;
import static org.lwjgl.opengl.GL11.glDisableClientState;
import static org.lwjgl.opengl.GL11.glDrawArrays;
import static org.lwjgl.opengl.GL11.glEnableClientState;
import static org.lwjgl.opengl.GL11.glEnd;
import static org.lwjgl.opengl.GL11.glEndList;
import static org.lwjgl.opengl.GL11.glGenLists;
import static org.lwjgl.opengl.GL11.glNewList;

import static org.lwjgl.opengl.GL11.glVertexPointer;

import java.nio.FloatBuffer;

import java.util.Random;

import org.lwjgl.BufferUtils;
import org.lwjgl.Sys;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL15;
import org.lwjgl.opengl.GLContext;

import blocks.BarkBlock;
import blocks.BedrockBlock;
import blocks.BloomeryBlock;
import blocks.BrickBlock;
import blocks.GlassBlock;
import blocks.GrassBlock;
import blocks.GravelBlock;
import blocks.LeafBlock;
import blocks.NormalStoneBlock;
import blocks.PebbelBlock;
import blocks.PlankBlock;
import blocks.PlantBlock;
import blocks.SandBlock;
import blocks.SoilBlock;
import blocks.StoneBlock;
import blocks.WaterBlock;
import blocks.WorkBenchBlock;

public class Chunk16Colour {
	public byte face=0;
	private byte[][][] chunk;
	private byte[][][] lightData;
	public final int CHUNKHEIGHT = 128;
	public final int CHUNKBLOCKS = 16* CHUNKHEIGHT * 16;
	public final int GROUNDLEVEL = 40;
	public final int WATERLEVEL = 44;
	public boolean water=false;
	Random rand = new Random();
	int chance = 0;
	int bufferID=0;
	public int displaylistID;
	public int WaterlistID;
	public int TdisplaylistID;

	public int getBlockcount() {
		return blockcount;
	}

	public void setBlockcount(int blockcount) {
		this.blockcount = blockcount;
	}
	public String name;
	public FloatBuffer vHandle; //the float buffer
	public int vboV=0;//vertex
	int vboT;//texture
	int vertSize = 3; //float = 3
	int vertAmount = 4;//quad
	int faceAmount = 6; //cube
	int blockAmount = CHUNKBLOCKS; //16*16*16 cubes
	int startX;//x of chunk
	int startZ;//y of chunk
	int startY;//z of chunk
	int blockcount = 0;
	
	
	public Chunk16Colour(int x, int z, String name,int ID) { //new chunk
		startX=x;
		startY=0;
		startZ=z;
		displaylistID = glGenLists(ID);
		WaterlistID = glGenLists(ID+64);
		TdisplaylistID = glGenLists(ID+128);
		// z,y,x
		chunk = new byte[16][CHUNKHEIGHT][16];
		lightData = new byte[16][CHUNKHEIGHT][16];
		this.name=name;
		
		for (int yC = 0; yC < CHUNKHEIGHT; yC++){
			for (int xC = 0; xC < 16; xC++) {
				for (int zC = 0; zC < 16; zC++) {			
					
					
					
						chunk[xC][yC][zC] =0; // air
						lightData[xC][yC][zC]=0;
					
				

					
					
					
				}
				
				
			}

		}
		
	
	}

	public void buildVertexData(){
		
	//	System.out.println("DisplayID = " + displaylistID);
		
		 glNewList(displaylistID, GL_COMPILE);
		 GL11.glBegin(GL11.GL_QUADS);
		
		int xOset; int yOset; int zOset; //block offsets
			
		float s= 0.0625f; //texture size 1/16
		for(xOset = 0;xOset<16;xOset++){
			for(yOset =0;yOset<CHUNKHEIGHT;yOset++){
				for(zOset = 0;zOset<16;zOset++){
		
		if(this.getblockID(xOset, yOset, zOset)>0 && this.getblockID(xOset, yOset, zOset)<50){ //50 is water
		
		
		int bID = this.getblockID(xOset, yOset, zOset);

		
		float tint =((float)(getLightData(xOset, yOset, zOset))/120f);
		face= 0;
		
		
		if(xOset>0){//check the right block
			if(this.getblockID(xOset-1, yOset, zOset)==0 || this.getblockID(xOset-1, yOset, zOset)>49) face+=1;
		}
		if(xOset==0) {
			//int b = leftChunk.getblockID(x, y, z);
			face+=1; 
		}
		
		
		if(xOset<15){//check the left block
			if(this.getblockID(xOset+1, yOset, zOset)==0 || this.getblockID(xOset+1, yOset, zOset)>49) face+=2;
		}
		
		
		if(xOset==15) {
			//int b = leftChunk.getblockID(x, y, z);
			face+=2; 
		}
		
		if(zOset>0){//check the south block
			if(this.getblockID(xOset, yOset, zOset-1)==0 || this.getblockID(xOset, yOset, zOset-1)>49) face+=4;
		}
		
		if(zOset==0) {
			//int b = leftChunk.getblockID(x, y, z);
			face+=4; 
		}
		
		if(zOset<15){//check the north block
			if(this.getblockID(xOset, yOset, zOset+1)==0 || this.getblockID(xOset, yOset, zOset+1)>49) face+=8;
		}
		if(zOset==15) {
			//int b = leftChunk.getblockID(x, y, z);
			face+=8; 
		}
		
		
		if(yOset>0){//check the north block
			if(this.getblockID(xOset, yOset-1, zOset)==0 || this.getblockID(xOset, yOset-1, zOset)>49) face+=16;
		}
		if(yOset<CHUNKHEIGHT){//check the north block
			if(this.getblockID(xOset, yOset+1, zOset)==0 || this.getblockID(xOset, yOset+1, zOset)>49 ) face+=32;
		}
		//|| this.getblockID(xOset, yOset+1, zOset)== 3
		 
		
		
		

		if(bID==1) SoilBlock.VertexDataDL( xOset, yOset, zOset,tint, face);//soil
		if(bID==2) SandBlock.VertexDataDL( xOset, yOset, zOset, tint,face);//sand
		if(bID==3) GrassBlock.VertexDataDL( xOset, yOset, zOset, tint,face);//grass
		if(bID==4) StoneBlock.VertexDataDL( xOset, yOset, zOset, tint,face);//stone
		//5 - tilled soil
		if(bID==6) GravelBlock.VertexDataDL( xOset, yOset, zOset, tint,face);//stone
		if(bID==7) BedrockBlock.VertexDataDL( xOset, yOset, zOset, tint,face);//stone
		if(bID==8) BarkBlock.VertexDataDL( xOset, yOset, zOset, tint,face);//grass
		if(bID==30) WorkBenchBlock.VertexDataDL( xOset, yOset, zOset, tint,face);//BrickBLock
		if(bID==31) BloomeryBlock.VertexDataDL( xOset, yOset, zOset, tint,face);//BrickBLock

		
		
			//blockcount++;
				}
			}
		}
		
		}

		  glEnd();
		  glEndList();
	}
	
	
	public void buildWaterVertexData(){
		

		
		glNewList(WaterlistID, GL_COMPILE);
		GL11.glBegin(GL11.GL_QUADS);
		
		int xOset; int yOset; int zOset; //block offsets
		yOset = WATERLEVEL;
		
		float s= 0.0625f; //texture size 1/16
		for(xOset = 0;xOset<16;xOset++){
		//	for(yOset =0;yOset<CHUNKHEIGHT;yOset++){
				for(zOset = 0;zOset<16;zOset++){
		
					
					//this method set the water to an even tint
		//if(this.getblockID(xOset, yOset, zOset)>0 && this.getblockID(xOset, yOset, zOset)<50){ //50 is water
				if(this.getblockID(xOset, yOset, zOset)==50){ //50 is water
				
				//	int bID = this.getblockID(xOset, yOset, zOset);
								
					float tint =((float)(getLightData(xOset, yOset, zOset))/120f);
					//float tint =127f;
				//	face= 0;		
						//if(yOset<CHUNKHEIGHT){//check the top block
						//if(this.getblockID(xOset, yOset+1, zOset)==3 ) face+=32;
				
				
		
				//	all top faces are visable
				face = 32;

				WaterBlock.VertexDataDL( xOset, yOset, zOset, tint,face);
					}
							
				}
			}

		  glEnd();
		  glEndList();
	}
	
	

	
	public void buildTransparentVertexData(){
			
		
		glNewList(TdisplaylistID, GL_COMPILE);
		
		GL11.glBegin(GL11.GL_QUADS);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, 7);//select texture	
		int xOset; int yOset; int zOset; //block offsets				
		//float s = 0.0625f; // texture size 1/16
		
		for (xOset = 0; xOset < 16; xOset++) {
			for (yOset = 0; yOset < CHUNKHEIGHT; yOset++) {
				for (zOset = 0; zOset < 16; zOset++) {

					int bID = this.getblockID(xOset, yOset, zOset); 
					
					if (bID == 60){//Leafs
						 LeafBlock.VertexDataDL( xOset, yOset, zOset, 1,(byte)0,0);
					}
					
					if (bID == 61){//Glass
						 GlassBlock.VertexDataDL( xOset, yOset, zOset, 1,(byte)0,0);
					}
					
					
					if (bID ==70){//Grass Plant
						 PlantBlock.VertexDataDL( xOset, yOset, zOset, 1,(byte)0);
					}
					
				}
			}
			
		}
	
			  glEnd();
			  glEndList();
		}
	
	/**
	 * Get the Block ID for a given position in the chunk
	 * @param x 0-15
	 * @param y 0-127
	 * @param z 0-15
	 * @return the ID of the block at that position
	 */
	public int getblockID(int x,int y, int z){
		if(x>15){
			System.out.println("Chunk16 error: x= " + x);
			return 0;
		}
		if(z>15){
			System.out.println("Chunk16 error: z= " + z);
			return 0;
		}
		
		if(y>CHUNKHEIGHT-1){
			System.out.println("Chunk16 error: y= " + y);
			return 0;
		}
		
		//if(y>CHUNKHEIGHT)y=127;
		return chunk[x][y][z];
	}
	
	/**
	 * Returns true if a soild block exists at the specified position.
	 * @param x 0-15x
	 * @param y 0-127
	 * @param z 0-15
	 * @return boolean true if a soild block is at that position.
	 */
	public boolean isblockSolid(int x,int y, int z){
		if(y>CHUNKHEIGHT)y=CHUNKHEIGHT-1;
		if (chunk[x][y][z]==0) return false; 
		if(chunk[x][y][z]>49)return false;
		return true;
	}
	
	
	/**
	 * Returns the light value (byte 0-127)
	 * @param x 0-15
	 * @param y 0-127
	 * @param z 0-15
	 * @return the light value as a byte
	 */
	public byte getLightData(int x,int y, int z){
		return lightData[x][y][z];
	}
	

	public void setLightData(int x,int y, int z, byte ld){
		 lightData[x][y][z]=ld;
	}
	
	
	/**
	 * Main method to render soild blocks
	 */
	public void render() {
		
		glCallList(displaylistID);		
	
		}
	
	/**
	 * Method to render the liquid areas of the map.
	 */
	public void renderWater(){
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, 7);//select texture
		GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
		GL11.glEnable(GL11.GL_BLEND);
		glCallList(WaterlistID);
		GL11.glDisable(GL11.GL_BLEND);
			}
	
	/**
	 * Method renders blocks with transparent areas.
	 * This method does not render liquids.
	 */
	public void renderTransparent(){
		glCallList(TdisplaylistID);
		}
		
	
/**
 * This method sets a block of given ID to the specified location in the chunk.
 * The soild vertex date is then updated. Vertex data for liquids and translucent blocks is not
 * updated.
 * @param x 0-15
 * @param y 0-127
 * @param z 0-15
 * @param id the byte ID of the block to be set.
 */
public void  setblockID(int x,int y, int z,byte id){
				
		chunk[x][y][z]=id;
		lightData[x][y][z]=100;
		
//		for(int yD=y-1;yD>-1;yD--){
//			if(chunk[x][yD+1][z]==0 && chunk[x][yD][z]>0){
//				
//			}
//		}
				
		buildVertexData();
	}


public void loadblockData(int x,int y, int z,byte id){
chunk[x][y][z]=id;
lightData[x][y][z]=100;
}


/**
 * Rebuilds the vertex data of soild blocks only.
 */
public void updateBuffer(){
	buildVertexData();
}



public String getName(){
	return this.name;
}
	

/**
 * This method generates a new chunk based on a diamon start algorithm.
 * The chunk takes the adjacent chunks as perameters. If not chunks exist in the 
 * given direction (0), new data will be constructed.
 * @param nw
 * @param ne
 * @param sw
 * @param se
 */
public void DiamondCunk(int nw, int ne, int sw, int se){
	
	//initial levels if they are empty
	if(nw==0) nw = rand.nextInt(10)+GROUNDLEVEL; 
	if(ne==0) ne = rand.nextInt(10)+GROUNDLEVEL;
	if(sw==0) sw = rand.nextInt(10)+GROUNDLEVEL;
	if(se==0) se = rand.nextInt(10)+GROUNDLEVEL;
	
	//make grasss blocks for the corners
	chunk[15][nw][15]=3; lightData[15][nw][15]= (byte)(( rand.nextInt(15) + 100));	  //(( rand.nextInt(5)* 12) +60);	
	chunk[0][ne][15]=3;  lightData[0][ne][15]= (byte)(( rand.nextInt(15) + 100));
	chunk[15][sw][0]=3; lightData[15][sw][0]= (byte)(( rand.nextInt(15) + 100));	
	chunk[0][se][0]=3;  lightData[0][se][0]= (byte)(( rand.nextInt(15) + 100));
	
	
	int h=0;
	float step=((ne-nw)/14f);
	
	for(int i=1;i<15;i++){	//top row	
		h=(int)(-step*i)+ne;
		chunk[i][h][15]=3;
		lightData[i][h][15]= (byte)(( rand.nextInt(15) + 100));
	}
	
	
	step=((se-sw)/14f);
	for(int i=1;i<15;i++){	//top row	
		h=(int)(-step*i)+se;
		chunk[i][h][0]=3;
		lightData[i][h][0]= (byte)(( rand.nextInt(15) + 100));
	}
	
	step=((ne-se)/14f);
	for(int i=1;i<15;i++){	//right
		h=(int)(step*i)+se;
		chunk[0][h][i]=3;
		lightData[0][h][i]= (byte)(( rand.nextInt(15) + 100));
	}
	
	step=((nw-sw)/14f);
	for(int i=1;i<15;i++){	//right
		h=(int)(step*i)+sw;
		chunk[15][h][i]=3;
		lightData[15][h][i]= (byte)(( rand.nextInt(15) + 100));
	}
	
	//Iterate through the rows, north to south
	for(int d= 1;d<15;d++){
		int he=0;
		int hw=0;
	//get height of the ends 
		//east end
		for(int hi =0;hi<CHUNKHEIGHT;hi++){
			if(chunk[0][hi][d]>0)he=hi;
		}
		//west
		for(int hi =0;hi<CHUNKHEIGHT;hi++){
			if(chunk[15][hi][d]>0)hw=hi;
		}
	
		step=(he-hw)/14f;
	
	for(int i=1;i<15;i++){	//top row	
		h=(int)(-step*i)+he;
		chunk[i][h][d]=3;
		lightData[i][h][d]= (byte)(( rand.nextInt(15) + 100));
	}
	
	}
	
	//scan chunks and build stone
	boolean Stone=false;
	for(int a = 0;a<16;a++){
		for(int d = 0;d<16;d++){
			Stone=false;
			
			for(int hi = CHUNKHEIGHT-1;hi>0;hi--){
				
						if(Stone){
							chunk[a][hi][d]=4;
							lightData[a][hi][d]=(byte)(128-(128-CHUNKHEIGHT/2.5f));
						}
						
					
					
						if(chunk[a][hi][d]==3 && Stone == false & hi<WATERLEVEL){
							chunk[a][hi][d]=2;
							Stone = true; //fill with sand, then stone
						} else {
							if(chunk[a][hi][d]==3 && Stone == false)
							
								Stone = true;
						}
					
					
				}
			
			
			
		}
		
	}

	buildVertexData();
}

/**
 * This method generates water on the map then builds the water vertex data.
 * WATERLEVEL is used as a parameter.
 */
public void generateWater(){
	for(int a = 0;a<16;a++){
		for(int d = 0;d<16;d++){
			
			water=false;
			
			for(int hi = WATERLEVEL;hi>GROUNDLEVEL;hi--){
				
						//if(chunk[a][hi][d]>0)water = true;
						if(chunk[a][hi][d]==0 ){
							chunk[a][hi][d]=50;//fill with water
							lightData[a][hi][d]=50;
						}
													
				}
			}
						
		}
	

	buildWaterVertexData();

	}

/**
 * This method is used to generate a tree at a given X,Z location
 * The method scans the chunk vertically, if a soil location is available a tree is constructed.
 * This method builds the vertex, and Transparent vertex data.
 * @param a
 * @param d
 * @return true if a tree has been generated.
 */
public boolean addTree(int a, int d){
	

			int th = rand.nextInt(5)+5;
			
			for(int hi = CHUNKHEIGHT-1;hi>0;hi--){
				
						if(chunk[a][hi][d]==50)return false;
						if(chunk[a][hi][d]==3){
							//make the trunk
							for(int hight=0;hight<th;hight++){
								chunk[a][hi + hight + 1][d]=8;//tree bark								
								lightData[a][hi + hight + 1][d]=120;
								
							}
//							chunk[a][hi + th + 1][d]=6;//leafs
//							
//							chunk[a+1][hi + th ][d]=6;//leafs
//							chunk[a][hi + th ][d+1]=6;//leafs
//							chunk[a-1][hi + th ][d]=6;//leafs
//							chunk[a][hi + th ][d-1]=6;//leafs
							
							buildVertexData();
							buildTransparentVertexData();
							return true; //made tree
						}
				}
		return false;
	}


/**
 * This method adds a grass plan at a given X,Z position if grass is present.
 * This method rebuilds the Transparent vertex data.
 * @param a
 * @param d
 */
public void addGrass(int a, int d){
	
	for(int hi = CHUNKHEIGHT-1;hi>0;hi--){
		
				if(chunk[a][hi][d]==5){
				
						chunk[a][hi +  1][d]=14;//plant							
						lightData[a][hi + 1][d]=120;
						
				}
											
		}
	
	//buildVertexData();
	buildTransparentVertexData();	



}



public int getX(){
	return this.startX*16;
}

public int getZ(){
	return this.startZ*16;
}

public int getXindex(){
	return this.startX;
}

public int getZindex(){
	return this.startZ;
}

/**
 * This method returns the height of terrain, including water,
 * and grass plans.
 * Normally only used during Chunk generation.
 * @param x
 * @param z
 * @return the height of the terrain.
 */
public int getHeight(int x, int z){
	for(int h = CHUNKHEIGHT-1;h>-1;h--){
		if(chunk[x][h][z]>0)return h;
	}
	return 0;
}

public void setStartX(int startX) {
	this.startX = startX;
}

public void setStartZ(int startZ) {
	this.startZ = startZ;
}

public void clearArray(){
	for (int xC = 0; xC < 16; xC++) {
		for (int zC = 0; zC < 16; zC++) {
			for (int yC = 0; yC < CHUNKHEIGHT; yC++) {
				chunk[xC][yC][zC]=0;
			}
			}
}
}
}
