package level;


import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.ObjectInputStream.GetField;
import java.util.ArrayList;
import java.util.List;

import javax.imageio.ImageIO;


public class Level {

	private byte[][] tiles;
	public int width;
	public int height;

	private String imagePath;
	private BufferedImage image;
	
	
	public Level(String imagePath){//this was width * Height
		if(imagePath != null){
			this.imagePath = imagePath;
			this.loadLevelFromFile();
			
			System.out.println("level loaded ok");
		}else{ //if no image generate on the fly		
		this.width = 64;
		this.height = 64;	
		tiles = new byte[width][height];		
		System.out.println("level not found");
		}
	}
	
	

	private void loadLevelFromFile(){
		try {
			this.image = ImageIO.read(Level.class.getResource(this.imagePath));
			this.width = image.getWidth();
			this.height = image.getHeight();
			tiles = new byte[width][ height];
			this.loadTiles();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	
	private void loadTiles(){
		int [] tileColours = this.image.getRGB(0, 0 ,width,height, null, 0, width);
		
		for(int y= 0;y<1;y++){
			for(int x =0;x<10;x++){
				
				int Red = ( this.image.getRGB(x, y) >> 16) & 0xFF;
				
			System.out.println("level: " +Red)	;
			
						
						
					}
				}
			}
		
	
	
	
	@SuppressWarnings("unused")
	private void saveLevelToFile(){
		try{
			ImageIO.write(image, "png", new File(Level.class.getResource(this.imagePath).getFile()));
		}catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public void alterTile(int x, int y, int id){
		
		image.setRGB(x, y, id);
	}



	public void LoadChunk(Chunk16Colour chunk) {
		for(int y= 0;y<16;y++){
			for(int x =0;x<16;x++){
				
				//int Red = ( this.image.getRGB(x+chunk.getX(), y+chunk.getZ()) >> 16) & 0xFF;
				
				int height = ((( this.image.getRGB(x+chunk.getX(), y+chunk.getZ()) >> 16) & 0xFF)+10)/10;
				
				for (int h=0;h<height;h++){
					byte bid =  1;
					if(h==height-1)bid = 5;
					
					//chunk.setLightData(x, h, y,(byte)100);
					chunk.loadblockData(x, h, y, bid);
					
				}
						
				
					}
				}
			}
		
	}
	
	
	
	
	

	
	
	
	







