package main;

import static org.lwjgl.opengl.ARBBufferObject.glBindBufferARB;
import static org.lwjgl.opengl.ARBVertexBufferObject.GL_ARRAY_BUFFER_ARB;
import static org.lwjgl.opengl.GL11.GL_COLOR_BUFFER_BIT;
import static org.lwjgl.opengl.GL11.GL_COLOR_MATERIAL;
import static org.lwjgl.opengl.GL11.GL_DEPTH_BUFFER_BIT;
import static org.lwjgl.opengl.GL11.GL_FALSE;
import static org.lwjgl.opengl.GL11.GL_FLOAT;
import static org.lwjgl.opengl.GL11.GL_FRONT;
import static org.lwjgl.opengl.GL11.GL_MODELVIEW;
import static org.lwjgl.opengl.GL11.GL_PROJECTION;
import static org.lwjgl.opengl.GL11.GL_STENCIL_BUFFER_BIT;
import static org.lwjgl.opengl.GL11.GL_VERTEX_ARRAY;
import static org.lwjgl.opengl.GL11.glClear;
import static org.lwjgl.opengl.GL11.glColorMaterial;
import static org.lwjgl.opengl.GL11.glDisableClientState;
import static org.lwjgl.opengl.GL11.glDrawArrays;
import static org.lwjgl.opengl.GL11.glEnable;
import static org.lwjgl.opengl.GL11.glEnableClientState;
import static org.lwjgl.opengl.GL11.glLoadIdentity;
import static org.lwjgl.opengl.GL11.glMatrixMode;
import static org.lwjgl.opengl.GL11.glTranslatef;
import static org.lwjgl.opengl.GL11.glVertexPointer;
import static org.lwjgl.opengl.GL20.GL_COMPILE_STATUS;
import static org.lwjgl.opengl.GL20.GL_FRAGMENT_SHADER;
import static org.lwjgl.opengl.GL20.GL_VERTEX_SHADER;
import static org.lwjgl.opengl.GL20.glAttachShader;
import static org.lwjgl.opengl.GL20.glCompileShader;
import static org.lwjgl.opengl.GL20.glCreateProgram;
import static org.lwjgl.opengl.GL20.glCreateShader;
import static org.lwjgl.opengl.GL20.glDeleteProgram;
import static org.lwjgl.opengl.GL20.glDeleteShader;
import static org.lwjgl.opengl.GL20.glLinkProgram;
import static org.lwjgl.opengl.GL20.glShaderSource;
import static org.lwjgl.opengl.GL20.glUseProgram;
import static org.lwjgl.opengl.GL20.glValidateProgram;
import static org.lwjgl.opengl.GL13.GL_TEXTURE0;
import static org.lwjgl.opengl.GL13.glActiveTexture;

import gfx.BitmapFont;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;
import java.util.ArrayList;
import java.util.Random;

import javax.print.attribute.standard.Chromaticity;

import level.Chunk16Colour;
import level.Level;
import level.ReadWriteTextFile;
import objects.Axe;
import objects.Bellows;
import objects.Furnace;

import org.lwjgl.BufferUtils;
import org.lwjgl.LWJGLException;
import org.lwjgl.Sys;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.openal.AL;
import org.lwjgl.openal.AL10;
import org.lwjgl.opengl.ARBVertexBufferObject;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL13;
import org.lwjgl.opengl.GL20;
import org.lwjgl.opengl.GLContext;
import org.lwjgl.util.Point;
import org.lwjgl.util.WaveData;
import org.lwjgl.util.glu.GLU;
import org.lwjgl.util.vector.Vector3f;
import org.newdawn.slick.Color;
import org.newdawn.slick.opengl.Texture;
import org.newdawn.slick.opengl.TextureLoader;
import org.newdawn.slick.util.ResourceLoader;

import privatives.CubeColour;
import privatives.Cuboid;
import privatives.Plant;
import privatives.Quad;
import privatives.Water;
import privatives.cube;
import window.DebugWindow;
import window.MapWindow;
import window.MessageWindow;
import window.bagWindow;
import Entitys.Entity;
import Entitys.EntityBlock;
import audio.Sound;
import blocks.BarkBlock;
import blocks.BedrockBlock;
import blocks.BloomeryBlock;
import blocks.FaceBlock;
import blocks.GlassBlock;
import blocks.GrassBlock;
import blocks.GravelBlock;
import blocks.LanternBlock;
import blocks.LeafBlock;
import blocks.PebbelBlock;
import blocks.PlankBlock;
import blocks.SandBlock;
import blocks.SkyBlock;
import blocks.SoilBlock;
import blocks.StoneBlock;
import blocks.WorkBenchBlock;

public class Main {
	//vsync
		boolean vSync = true;			
		boolean random = true;
		public static int blockcount=0; 
		public int timer = 0;
		org.lwjgl.input.Cursor emptyCursor;
		org.lwjgl.input.Cursor VisableCursor;
		boolean hideCursor= true;
		int itemNum=1;
		Texture texture;
		Texture font;
		
		public float CloudX = 40.0f;

		String windowTitle = "3d Game v.0.2";
		boolean closeRequested = false;
		int tick = 0;
		int textureID = 0;
		
		public float Wx = 0;
		public float Wy = 0;
	
		//camera or eye
		float piover180 = 0.0174532925f;
		float heading;
		float xpos = 25;
		float zpos =25;
		float camHieght;
		Vector3f camVector = new Vector3f(0,0,0);
		float blockX;
		float bloxkZ;
		boolean running=false;
		float runtime=0;
		public int runINTERVAL= 10; //in ticks
		public float runBoost = 0;
		public float runningCountdown=0; //in ticks
		boolean isJumping= false;
		float ground = 0.0f;
		float yVelocity=0.0f;
		final double TIME_STEP=1/60.0;
		public float GRAVITY=-11f;
		boolean gui = false;
		BitmapFont Gamefont;
		int breakerBlockStep=0;
		int breakerCounter=0;
		boolean broken = false;
		float yrot = 0;// Y Rotation
		float walkbias;
		float playerheight = 0.0f;
		float hedHeight = 1.8f;
		float walkbiasangle = 0;
		public static float bobBias=0;
		public static float swimspeed= 0;
		public static float jumpVel = 0;
		public int placeBlockTimer=0;
		
		
		
		float lookupdown = 0;
		float z = 0; // Depth Into The Screen
		boolean helperVisible = true;
		private float FOV = 45.0f;
		public boolean breaking = false;
		int lastMouseX = 0;
		int lastMouseY = 0;
		Random rand;
		Sound sound;
		public float f = 0;
		
		long lastFrame;			
		int fps;	
		long lastFPS;
		
		boolean furnaceGui=false;
		boolean WorkbenchGui=false;
	
		public float Yh=0; public float YDist=0f;
		public float Zh=0; public float ZDist=0f;
		public float Xh=0; public float XDist=0f;
		float Xd=0;
		float Yd=0;
		float Zd=0;
		float LastXd=0;
		float LastYd=0;
		float LastZd=0;
		
		
		public float CamX = 0f;public float CamY = 0f;public float CamZ = 0f;
		public float InX = 0f;public float InY = 0f;public float InZ = 0f;
		
		//the cube that is used - to be changed to a VBO
		cube block = new cube(0.5f);
		CubeColour blockColour = new CubeColour(0.5f);
		
		int helperFace=0;
		cube helperBlock =new cube(0.01f);
		cube helperBlock2 =new cube(0.505f);
		cube chunkBlock = new cube(8f);
		Axe axe = new Axe();
		CubeColour playerBlock = new CubeColour(0.06f);
		Cuboid soilBlock = new Cuboid(0.4f, 0.5f);
		Plant plantBlock = new Plant( 0.5f);
		
		Quad quad = new Quad();
		cube BreakerBlock = new cube(0.501f);
	
		//fog

		   public  float fogNear =2f;		
		   public  float fogFar = 10f;		
		   public Color fogColor = new Color(0.4f, 0.7f, 0.8f, 1f);
		   public Color fogColorWater = new Color(0.2f, 0.3f, 0.5f, 1f);
		
		int mouseX;
		int mouseLastX;
		int mouseLastY;
		int curentCunk = 0;
		float helperX = 6.0f;
		float helperZ =6.0f;
		float helperY =1.0f;
		
		boolean inWater = false;
		boolean lastInwater = false;
		
		boolean key1Clicked = false;
		boolean key2Clicked = false;
		boolean keyPClicked = false;
		boolean keyOClicked = false;
		boolean MleftClicked = false;
		double red;
		double green;
		double blue;
		double alpha;
		
		
		 public Level level = new Level("water_test_level.png");
		   
		 public static  int vcHandle;
		 public static FloatBuffer vcBuffer;
		 public static IntBuffer ib;
		 
		 //chunk setting
		 public int numberOfChunks=64;
		 public int mapWidth  = (int)Math.sqrt(numberOfChunks);
		// public Chunk16Colour chunks[] = new Chunk16Colour[numberOfChunks];
		 public Chunk16Colour chunks[][] = new Chunk16Colour[mapWidth][mapWidth];
		 public int chunkX=0;
		 public int chunkZ=0;
		 public int lastChunk =0;
		 
		 
		 public int resolution = 20;
		 public Vector3f[] helpers = new Vector3f[100];
		 public int helperCounter =0;
		 public boolean helperOnBlock=false;
		 
		 public ArrayList<EntityBlock> entities = new ArrayList<EntityBlock>();
		 
		 //shaders
		 	int shaderProgram ;//= glCreateProgram();
	        int vertexShader;// = glCreateShader(GL_VERTEX_SHADER);
	        int fragmentShader;// = glCreateShader(GL_FRAGMENT_SHADER);
	        CubeColour shaderCube= new CubeColour(3f);
	        
	        FloatBuffer fogColours;
	        FloatBuffer fogColoursWater;
	        
	        
	        public bagWindow inventory = new bagWindow("INVENTORY" ,680, 600,5*64+8,2*64+8);
	    //	public MapWindow mapWindow = new MapWindow("MAP (M)" ,820, 10,200,200);
	    //	public MessageWindow console = new MessageWindow("GAME DIALOGUE (N)" ,10, 680,500,80);
	    	public DebugWindow debug = new DebugWindow("DEBUG WINDOW (4)" ,10, 10,300,60);
		 
		
		/***************************************************************************************************************************************************************************************************
		 * Initialization stuff comes in here...
		 **************************************************************************************************************************************************************************************************/
		private void init() {
			
			rand= new Random();
			
			try {
				Display.setDisplayMode(new DisplayMode(1024, 768));  //800,600 etc
				Display.setVSyncEnabled(vSync); //will reduce tearing
				Display.setTitle(this.windowTitle); 
				Display.create();
				Keyboard.create();
				//IL.create();  
				//ILU.create();

			} catch (LWJGLException e) {
				Sys.alert("Error", "Initialization failed!\n\n" + e.getMessage());
				System.exit(0);
			}
			
			/* Initialize OpenGL */
			int width = Display.getDisplayMode().getWidth(); // Get window width
			int height = Display.getDisplayMode().getHeight(); // Get window height

			GL11.glViewport(0, 0, width, height); // Reset The Current Viewport
			GL11.glMatrixMode(GL11.GL_PROJECTION); // Select The Projection Matrix
			GL11.glLoadIdentity(); // Reset The Projection Matrix
			//60.0f is the Field of Vision
			
			GLU.gluPerspective(FOV, ((float) width / (float) height), 0.1f, 200.0f); // Calculate The Aspect Ratio Of The Window
			GL11.glMatrixMode(GL11.GL_MODELVIEW); // Select The Modelview Matrix
			GL11.glLoadIdentity(); // Reset The Modelview Matrix

			GL11.glEnable(GL11.GL_TEXTURE_2D); // Enable Texture Mapping 
			//GL11.glShadeModel(GL11.GL_SMOOTH); // Enables Smooth Shading
			GL11.glClearColor(0.1f, 0.4f, 0.6f, 0.0f); // Background R G B A
			GL11.glClearDepth(1.0f); // Depth Buffer Setup
			GL11.glEnable(GL11.GL_DEPTH_TEST); // Enables Depth Testing
			GL11.glDepthFunc(GL11.GL_LEQUAL); // The Type Of Depth Test To Do
			GL11.glHint(GL11.GL_PERSPECTIVE_CORRECTION_HINT, GL11.GL_NICEST); // Really Nice Perspective Calculations
			
		
			//Cull faces - Only draw the front face
			GL11.glCullFace(GL11.GL_BACK);
			GL11.glEnable(GL11.GL_CULL_FACE);
			
			GL11.glEnable(GL11.GL_FOG);

	        {
	            fogColours = BufferUtils.createFloatBuffer(
	                    4);
	            fogColours.put(new float[]{fogColor.r, fogColor.g, fogColor.b, fogColor.a});
	            GL11.glClearColor(fogColor.r, fogColor.g, fogColor.b, fogColor.a);
	            fogColours.flip();
	            fogColoursWater = BufferUtils.createFloatBuffer(
	                    4);
	            fogColoursWater.put(new float[]{fogColorWater.r, fogColorWater.g, fogColorWater.b, fogColorWater.a});
	            GL11.glClearColor(fogColorWater.r, fogColorWater.g, fogColorWater.b, fogColorWater.a);
	            fogColoursWater.flip();
	            
	            GL11.glFog(GL11.GL_FOG_COLOR, fogColours);
	            GL11.glFogi(GL11.GL_FOG_MODE, GL11.GL_LINEAR);
	            GL11.glHint(GL11.GL_FOG_HINT, GL11.GL_NICEST);
	            GL11.glFogf(GL11.GL_FOG_START, fogNear);
	            GL11.glFogf(GL11.GL_FOG_END, fogFar);
	            GL11.glFogf(GL11.GL_FOG_DENSITY, 0.001f);
	        }
			
			// Load textures
			
			try {
				texture = TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("res/terrain2.png"));
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}
			
			//Color.white.bind();
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 1);
			GL11.glTexParameteri(GL11.GL_TEXTURE_2D,GL11.GL_TEXTURE_MAG_FILTER,GL11.GL_NEAREST);
			GL11.glTexParameteri(GL11.GL_TEXTURE_2D,GL11.GL_TEXTURE_MIN_FILTER,GL11.GL_NEAREST);
		
			
			
			//generate the chunks
			for(int yC = 0;yC <mapWidth;yC++){			
				for(int xC = 0;xC <mapWidth;xC++){					
					chunks[xC][yC] = new Chunk16Colour(xC, yC,""+ (char)(yC+48)+(char)(xC+48),1/*xC+(mapWidth*yC)*/);
					}
				
			}
			
			
			//generate randomness
			for(int yC = 0;yC <mapWidth;yC++){			
				for(int xC = 0;xC <mapWidth;xC++){		
					
					if (xC== 0) {// if the chunk is on the end x=0
					
						if (yC == 0) {
							chunks[xC][yC].DiamondCunk(0, 0, 0, 0); //the first chunk
						}else{
							chunks[xC][yC].DiamondCunk(0,0,chunks[xC][yC-1].getHeight(15, 15),chunks[xC][yC-1].getHeight(0,15));
						}
					}
				
				
				
				if(xC>0){//if the chunk is not on the end x=0 	chunks[i].DiamondCunk(nw, ne, sw, se);
					if (yC > 0 ) {//if its no the first row
						chunks[xC][yC].DiamondCunk(0,chunks[xC-1][yC].getHeight(15, 15),chunks[xC][yC-1].getHeight(15, 15),chunks[xC-1][yC].getHeight(15, 0));
					}else{
						chunks[xC][yC].DiamondCunk(0,chunks[xC-1][yC].getHeight(15, 15),0,chunks[xC-1][yC].getHeight(15, 0));
					}

				}
				}
			}
			
			//load the chunks into memory
				for(int yC = 0;yC <mapWidth;yC++){			
					for(int xC = 0;xC <mapWidth;xC++){	
						chunks[xC][yC].generateWater();
				
						}
				}
			
			//add random grass
			int treeX;
			int treeY;
			for (int loop = 0; loop < 200; loop++) {
				// make a random grass plan
				treeX = rand.nextInt(mapWidth * 16);
				treeY = rand.nextInt(mapWidth * 16);
	
				Point p = getChunk(treeX, treeY);
				chunks[p.getX()][p.getY()].addGrass(treeX % 16, treeY % 16);
			}
			
			
			for(int loop = 0;loop<10;loop++){
			//make a random tree
			 treeX = rand.nextInt(mapWidth*16);
			treeY = rand.nextInt(mapWidth*16);
			
			Point p = getChunk(treeX, treeY);
			chunks[p.getX()][p.getY()].addTree(treeX % 16, treeY % 16);
			}
			
			LoadTextures();
			
			
			//make the helpers for the 3D picking
			for(int i=0;i<helpers.length;i++){				
				helpers[i]= new Vector3f(0,0,0);
			}
			
			//random number generator
			rand = new Random();

			//player Settings			
			playerheight = 60;
			xpos = 8;//28;//3.5 blocks
			zpos = 8; // 28        ;
			chunkZ=3;
			
			
			
			inventory.addItem(4, 6);
			inventory.addItem(30, 1);
			inventory.addItem(31, 1);
			inventory.addItem(2, 32);
			inventory.addItem(60, 20);
			
			
			
			
			
			//initilise the shaders
			initShader();
			
			}
		
		private void LoadTextures() {
			//fonts
			try {
				 texture= TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("res/icons.png"));
				
			} catch (IOException e) {
					e.printStackTrace();
			}
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 2);
			Gamefont = new BitmapFont();
			
			//gui
			try {
				 texture= TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("res/gui.png"));
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 3);
			
			//windowBase
			try {
				 texture= TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("res/windowBase.png"));
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 4);
			
			
			//furnace
			try {
				 texture= TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("res/BlastFurnace.png"));
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 5);
			
			//furnace
			try {
				 texture= TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("res/cloud2.png"));
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 6);
			
			//furnace
			try {
				 texture= TextureLoader.getTexture("PNG", ResourceLoader.getResourceAsStream("res/water3.png"));
				
			} catch (IOException e) {
				
				e.printStackTrace();
			}
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 7);
		
		
			
		}

		public void  initShader(){
			 shaderProgram = glCreateProgram();
			 vertexShader = glCreateShader(GL_VERTEX_SHADER);
			 fragmentShader = glCreateShader(GL_FRAGMENT_SHADER);
			
		        StringBuilder vertexShaderSource = new StringBuilder();
		        StringBuilder fragmentShaderSource = new StringBuilder();
		        BufferedReader reader = null;
		        try {
		            reader = new BufferedReader(new FileReader("res/shader.vs"));
		            String line;
		            while ((line = reader.readLine()) != null) {
		                vertexShaderSource.append(line).append('\n');
		            }
		        } catch (IOException e) {
		            System.err.println("Vertex shader wasn't loaded properly.");
		            e.printStackTrace();
		            Display.destroy();
		            System.exit(1);
		        } finally {
		            if (reader != null) {
		                try {
		                    reader.close();
		                } catch (IOException e) {
		                    e.printStackTrace();
		                }
		            }
		        }
		        BufferedReader reader2 = null;
		        try {
		            reader2 = new BufferedReader(new FileReader("res/shader.fs"));
		            String line;
		            while ((line = reader2.readLine()) != null) {
		                fragmentShaderSource.append(line).append('\n');
		            }
		        } catch (IOException e) {
		            System.err.println("Fragment shader wasn't loaded properly.");
		            Display.destroy();
		            System.exit(1);
		        } finally {
		            if (reader2 != null) {
		                try {
		                    reader2.close();
		                } catch (IOException e) {
		                    e.printStackTrace();
		                }
		            }
		        }
		        glShaderSource(vertexShader, vertexShaderSource);
		        glCompileShader(vertexShader);
		     
		        if (GL20.glGetShader(vertexShader, GL_COMPILE_STATUS) == GL_FALSE) {
		            System.err.println("Vertex shader wasn't able to be compiled correctly.");
		       }
		        glShaderSource(fragmentShader, fragmentShaderSource);
		        glCompileShader(fragmentShader);
		        if (GL20.glGetShader(fragmentShader, GL_COMPILE_STATUS) == GL_FALSE) {
		            System.err.println("Fragment shader wasn't able to be compiled correctly.");
		        }
		        glAttachShader(shaderProgram, vertexShader);
		        glAttachShader(shaderProgram, fragmentShader);
		        glLinkProgram(shaderProgram);
		        glValidateProgram(shaderProgram);
		}


			

		/***************************************************************************************************************************************************************************************************
		 * All rendering happens here...
		 **************************************************************************************************************************************************************************************************/
		
		private void render() {
			
			GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT); // Clear Screen And Depth Buffer
//			
//			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 1);
//			GL11.glEnable(GL11.GL_CULL_FACE);
//			GL11.glPolygonMode(GL11.GL_FRONT, GL11.GL_FILL);
//			
//			
				GL11.glLoadIdentity();										
				GL11.glRotatef(lookupdown, 1.0f, 0, 0);
				GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0);
				GL11.glDisable(GL11.GL_DEPTH_TEST); // Enables Depth Testing	
				SkyBlock.RenderVertexColour(1, 1);				
				GL11.glEnable(GL11.GL_DEPTH_TEST); // Enables Depth Testing

				renderChunks();
				
				//	CamReset();
				//move the block infront of the player
				GL11.glTranslatef(20, 50 , 20);
							
			
			
			glUseProgram(shaderProgram);	
			
			GL11.glDisable(GL11.GL_CULL_FACE);			
			GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_FILL);
			renderTransparentBlocks();			
			glUseProgram(0);
			
			GL11.glPolygonMode(GL11.GL_FRONT, GL11.GL_FILL);			
			GL11.glEnable(GL11.GL_CULL_FACE);
			
//			
//			CamReset();
//			GL11.glTranslatef((int)(0.5+helperX),(int)(0.5+helperY), (int)(0.5+helperZ));	
//			 
//			FaceBlock.RenderVertexColour(1, 0.51f, helperFace);
//			 
			GL11.glEnable(GL11.GL_BLEND);
			//GL11.glBindTexture(GL11.GL_TEXTURE_2D, 1);//select texture
			CamReset();
			GL11.glTranslatef(Xh,Yh, Zh);			 
			FaceBlock.RenderVertexColour(1, 0.51f, helperFace);
			GL11.glDisable(GL11.GL_BLEND);
			//camra position
			CamReset();
			GL11.glTranslatef(CamX,CamY, CamZ);			 
			playerBlock.RenderVertexColour(1, 2 ,0, 0.3f);
			CamReset();
			GL11.glTranslatef(InX,InY, InZ);			 
			playerBlock.RenderVertexColour(1, 2 ,0, 0.01f);
			
			
			CamReset();
			GL11.glTranslatef(CloudX,80, 50);
			GL11.glScalef(8f, 8f, 8f);
			GL11.glRotatef(-90, 1, 0, 0);
			Bellows.RenderVertexColour(6);
				
			for(int i=0;i<entities.size();i++){
			//entities
			GL11.glLoadIdentity();			
			GL11.glRotatef(lookupdown, 1.0f, 0, 0);
			GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0);
			GL11.glTranslatef(-xpos, camHieght , -zpos);
			
			entities.get(i).render();
			//entityBlock.render();
			
			}
			// draw the block the player is holding
			GL11.glLoadIdentity();
			//move the camera
			GL11.glRotatef(20, 1.0f, 0, 0);  //lookupdown
			GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0); //360.0f - yrot
			GL11.glTranslatef(-xpos, (-walkbias/3) - 0.25f - (float)playerheight - hedHeight, -zpos);
			
			
			
			//draw the axe
			if(itemNum==100){
				if(breaking  && !broken && breakerBlockStep <6){ //if hitting something
					//move the block infront of the player
					float xblokpos = xpos - (float) Math.sin((yrot-10) * piover180) * 0.31f;
					float zblokpos = zpos - (float) Math.cos((yrot-10) * piover180) * 0.31f;
						
					GL11.glTranslatef(xblokpos, playerheight+1.89f, zblokpos);
					GL11.glRotatef(340.0f + yrot, 0,1f, 0f);
					 	
						GL11.glTranslatef(0, (walkbias/2.3f)+0.028f , 0);
						GL11.glRotatef(35, 0, 0, 1);
						
						GL11.glRotatef(-50, 0, 1, 0);
						GL11.glScalef(0.15f, 0.15f,0.15f);
					
				}else{
					
					
					//move the block infront of the player
					float xblokpos = xpos - (float) Math.sin((yrot-18) * piover180) * 0.24f;
					float zblokpos = zpos - (float) Math.cos((yrot-18) * piover180) * 0.24f;
						
					GL11.glTranslatef(xblokpos, playerheight+1.83f, zblokpos);
					GL11.glRotatef(340.0f + yrot, 0,1f, 0f);
					
					GL11.glTranslatef(0, (walkbias/2.3f)+0.028f , 0);
					GL11.glRotatef(10, 0, 0, 1);
					GL11.glRotatef(-50-(walkbias*4f), 0, 1, 0);
					GL11.glScalef(0.2f, 0.2f,0.2f);
					
				}
						
									
				
				Axe.RenderVertexColour(1,0.06f);
			}else{
			
			//move the block infront of the player
			float xblokpos = xpos - (float) Math.sin((yrot-18) * piover180) * 0.24f;
			float zblokpos = zpos - (float) Math.cos((yrot-18) * piover180) * 0.24f;
				
			GL11.glTranslatef(xblokpos, playerheight+1.83f, zblokpos);
			GL11.glRotatef(340.0f + yrot, 0,1f, 0f);
			
			
			//playerBlock.Render(1,0.5f,0f,0.25f);//stone
				GL11.glColor3f(1f,1f,1f);
			 //       block.Render(texture, Hoffset, Voffset, size)
				//if(itemNum==1) playerBlock.RenderVertexColour(1, 0.0f, 0.0f, 0.0625f);//soil
				if(itemNum==1) SoilBlock.RenderVertexColour(1,0.06f);
				if(itemNum==2) SandBlock.RenderVertexColour(1,0.06f);
				if(itemNum==3) GrassBlock.RenderVertexColour(1,0.06f);
				if(itemNum==4) StoneBlock.RenderVertexColour(1,0.06f);
				//5 - tilled soil
				if(itemNum==6) GravelBlock.RenderVertexColour(1,0.06f);
				if(itemNum==7) BedrockBlock.RenderVertexColour(1,0.06f);
				if(itemNum==8) BarkBlock.RenderVertexColour(1,0.06f);
				
				if(itemNum==30) WorkBenchBlock.RenderVertexColour(1,0.06f);
				if(itemNum==31) BloomeryBlock.RenderVertexColour(1,0.06f);
				
				if(itemNum==60) LeafBlock.RenderVertexColour(1,0.06f);
				if(itemNum==61) GlassBlock.RenderVertexColour(1,0.06f);
				
				
				
				
				
				
				
			}
				
			
			
				
		
				
				
				//position the player/camera
				
				GL11.glLoadIdentity();
				GL11.glRotatef(lookupdown, 1.0f, 0, 0);
				GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0);
				GL11.glTranslatef(-xpos, camHieght , -zpos);
//			
			  //draw3dLine(x1, x2, y1, y2, z1, z2)     //yep u can see it when its facing you!
				//draw3dLine(xpos, addXVector(5),1.01f, 1.01f, zpos,addZVector(5));
				if(breaking  && !broken){
				
				GL11.glTranslatef((int)(0.5+helperX),(int)(0.5+helperY), (int)(0.5+helperZ));	
				BreakerBlock.RenderBreakerBlock(1, breakerBlockStep, 1f-0.0625f, 0.0625f);
				}
			
				//GLU.gluUnProject(winx, winy, winz, modelMatrix, projMatrix, viewport, obj_pos)
				
				
			
				
			GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_LINE);
			
			
					
				//the helper block	
			//if(helperOnBlock){
			GL11.glLoadIdentity();
			
			//position the player/camera
			GL11.glRotatef(lookupdown, 1.0f, 0, 0);
			GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0);
			GL11.glTranslatef(-xpos, camHieght , -zpos);
			
			
			GL11.glDisable(GL11.GL_CULL_FACE);
			GL11.glColor3f(0f,0f,0f);
			GL11.glLineWidth(1);
			
			//if(helperVisible){
			//draw the helper block     - the helperblock should be an integer need to sort out the keyboad click
			//GL11.glTranslatef((int)Math.round(helperX-0.5),(int)Math.round(helperY-0.5), (int)Math.round(helperZ-0.5));
			
			GL11.glTranslatef((int)(0.5+helperX),(int)(0.5+helperY), (int)(0.5+helperZ));
			//GL11.glTranslatef(helperX,helperY, helperZ);
			//GL11.glRotatef(0, 0, 0, 0);
		//	helperBlock2.Render(1);
			
			
			//Draw the line from cam to intersect plane
			
			GL11.glLoadIdentity();
			
			//position the player/camera
			GL11.glRotatef(lookupdown, 1.0f, 0, 0);
			GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0);
			GL11.glTranslatef(-xpos, camHieght , -zpos);
			
			
			GL11.glDisable(GL11.GL_CULL_FACE);
			GL11.glColor3f(1f,1f,1f);
			GL11.glLineWidth(3);
			
			//if(helperVisible){
			//draw the helper block     - the helperblock should be an integer need to sort out the keyboad click
			//GL11.glTranslatef((int)Math.round(helperX-0.5),(int)Math.round(helperY-0.5), (int)Math.round(helperZ-0.5));
			
			//GL11.glTranslatef((int)(0.5+helperX),(int)(0.5+helperY), (int)(0.5+helperZ));
			//GL11.glTranslatef(helperX,helperY, helperZ);
			//GL11.glRotatef(0, 0, 0, 0);
			GL11.glBegin(GL11.GL_LINES);
			GL11.glVertex3f(CamX, CamY, CamZ);
			GL11.glVertex3f(InX,InY, InZ);
			GL11.glEnd();

			
			
			
			//}
	
//			//render a box around the chunks
//					GL11.glLoadIdentity();
//					GL11.glRotatef(lookupdown, 1.0f, 0, 0);
//					GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0);
//					GL11.glTranslatef(-xpos, camHieght , -zpos);
//					
//					GL11.glTranslatef(chunks[curentCunk].getX()+7.5f , 8.5f,chunks[curentCunk].getZ()+7.5f);
//					
//					GL11.glColor3f(0f,0f,0f);
//					chunkBlock.Render(1);
			
//			

//
				GL11.glPolygonMode(GL11.GL_FRONT, GL11.GL_FILL);
						
					
					GL11.glLoadIdentity();
					
					enterOrtho();
					GL11.glColor3f(1f,1f,1f);
					//render font gui
					//if(gui)quad.render(3);
					//Gamefont.drawString(0, "Test", 100, 100);
//					Gamefont.drawString( "X:" + (xpos + 0.5f) , 16,16,16);
//					Gamefont.drawString( "X:"+ (int)(xpos+0.5), 260,16,16);
//					Gamefont.drawString( "Z:" + (zpos + 0.5F) , 16,34,16);
//					Gamefont.drawString( "Z:"+ (int)(zpos+0.5), 260,34,16);
//					Gamefont.drawString( "Y:" + (playerheight +1), 16,52,16);
//					Gamefont.drawString( "Zchunk:" + chunkZ , 16,70,16);
//					Gamefont.drawString( "CHUNK:" + curentCunk, 16,88,16);
//					Gamefont.drawString( "ITEM:" + itemNum, 16,106,16);
//					Gamefont.drawString( "VIEW_TILT:" + lookupdown, 16,124,16);
					Gamefont.drawString( "+" , 504,392,16);
					
					
					inventory.RenderBag();
				//	mapWindow.Render(l1,(int)(xpos+0.5),(int)(zpos+0.5),getFacing(yrot));
				//	console.renderMessage();
					debug.RenderDebug((int)(xpos+0.5),playerheight, (int)(zpos+0.5));
					//stats.RenderStats();
					//render a line
				//	Point p1 = new Point(100, 100);
				//	Point p2 = new Point(300, 200);
				//	drawLine( p1 ,p2);
					
					if(WorkbenchGui)quad.render(5);
					
					leaveOrtho();
					
					GL11.glEnable(GL11.GL_CULL_FACE);
					
		}
		
		
	




		public void renderChunks(){
			
			CamReset();
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, 1);
			GL13.glActiveTexture(GL_TEXTURE0 + 0);
			
			//terrain layer
			GL11.glEnable(GL11.GL_CULL_FACE);
			GL11.glPolygonMode(GL11.GL_FRONT, GL11.GL_FILL);
			float m = 0.1f;
			
			for(int zC = 0;zC <mapWidth;zC++){			
				for(int xC = 0;xC <mapWidth;xC++){				
					//if(Math.abs(chunks[c].getX()-(int)xpos)<64){
					//	if(Math.abs(chunks[c].getZ()-(int)zpos)<64){
						GL11.glLoadIdentity();
						GL11.glRotatef(lookupdown, 1.0f, 0, 0);
						GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0);
						GL11.glTranslatef(-xpos, camHieght , -zpos);
						GL11.glBindTexture(GL11.GL_TEXTURE_2D, 1);
						//render4(chunks[c]);
						glTranslatef(chunks[xC][zC].getX(), 0f, chunks[xC][zC].getZ());
						chunks[xC][zC].render();
					
						//}
					//}
					}
				}
				GL11.glDisable(GL11.GL_CULL_FACE);
				GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_FILL);
				
				//water layer using shader with scroll
				glUseProgram(shaderProgram);
				int loc = GL20.glGetUniformLocation(shaderProgram, "u_texture");
				GL20.glUniform1i(loc, 0);			
				int loc1 = GL20.glGetUniformLocation(shaderProgram, "iGlobalTime");
			    //This is the location of the renderMode uniform variable in our program.
			    GL20.glUniform1f(loc1, f); 		    
			    //set scroll mode to 1 (scroll)
			    int loc2 = GL20.glGetUniformLocation(shaderProgram, "scroll");		    
			    GL20.glUniform1i(loc2, 1);
			    int loc3 = GL20.glGetUniformLocation(shaderProgram, "waterX");		    
			    GL20.glUniform1f(loc3, Wx);
			    int loc4 = GL20.glGetUniformLocation(shaderProgram, "waterY");		    
			    GL20.glUniform1f(loc4, Wy);
			    
				
			    for(int zC = 0;zC <mapWidth;zC++){			
					for(int xC = 0;xC <mapWidth;xC++){	
						CamReset();
						glTranslatef(chunks[xC][zC].getX(), 0f, chunks[xC][zC].getZ());
						chunks[xC][zC].renderWater();
					}
			    }
				GL11.glEnable(GL11.GL_CULL_FACE);
				GL20.glUniform1i(loc2, 0);
				glUseProgram(0);
				
		
				
		
			
		}

		private void renderTransparentBlocks() {
			
		int loc2 = GL20.glGetUniformLocation(shaderProgram, "scroll");		    
		 GL20.glUniform1i(loc2, 0);
		// GL11.glEnable(GL11.GL_BLEND);
		
			GL11.glDisable(GL11.GL_CULL_FACE);
			GL11.glPolygonMode(GL11.GL_FRONT_AND_BACK, GL11.GL_FILL);
			
			for(int zC = 0;zC <mapWidth;zC++){			
				for(int xC = 0;xC <mapWidth;xC++){
			
					CamReset();									
					glTranslatef(chunks[xC][zC].getX(), 0f, chunks[xC][zC].getZ());
					chunks[xC][zC].renderTransparent();
				}
			}
			 GL11.glEnable(GL11.GL_CULL_FACE);
			 GL11.glDisable(GL11.GL_BLEND);
			//glUseProgram(0);
			
			
		}

		/***************************************************************************************************************************************************************************************************
		 * Updates variables and such stuff
		 **************************************************************************************************************************************************************************************************/
		private void updateLogic() {
			
			timer += 1;
			if(timer>63)timer = 0;
			
			CloudX+=0.01f;
			
			if(timer%4==0){
					Wx += 0.25f;
					if(Wx>0.9f){
						Wx=0;
						Wy+=0.25;
						if(Wy>0.9f)Wy=0;
					}
			}
					
			itemNum= inventory.getCurrentItmeNum();
			//	curentCunk=getCurrentCunk();  this method need to be changed
			
				runningCountdown-=1;
				if(runningCountdown<=0){
					runBoost=0;
					running=false;
					//System.out.println("Not Running: " + runBoost);
				}
				
				if(inWater){
					
				swimspeed =-0.06f;
				jumpVel= 0;
				GRAVITY = -1f;
				}else{
				
					swimspeed =0;
					jumpVel=0;
					GRAVITY=-12;
				}
			
//				if(curentCunk!=lastChunk){
//					//need to generate some more chunks
//					
//					//moving in x
//					if(curentCunk==lastChunk+1)System.out.println("Moving in x <<<<");
//					
//					if(curentCunk==lastChunk-1)System.out.println("Moving in x   >>>>>");
//					
//					if(curentCunk==lastChunk+8){
//						chunkZ++;
//						if(chunkZ==8)chunkZ=0;
//						
//						System.out.println("Moving in Y north");
//						
//						//generate a row north cunks
//
//						NorthRowGenerator();
//						
//					}
//					
//					if(curentCunk==lastChunk-8)System.out.println("Moving in Y south");
//					
//				}
			if(placeBlockTimer>0)placeBlockTimer++;
			if(placeBlockTimer>32)placeBlockTimer=0;
			
			
				ground = getGroundLevel(xpos, playerheight, zpos);
				//System.out.println("ground = " + ground);
			
			
			 	playerheight+=yVelocity*TIME_STEP;
				yVelocity+=GRAVITY*TIME_STEP;
			
				if(playerheight<=ground)	{
					isJumping = false;
					yVelocity=0;
					playerheight= ground;
				}
				if(playerheight>120)playerheight=120;
			
				//update camera height
				camHieght =-walkbias - 0.25f - (float)playerheight - hedHeight;
				helperCounter=0;	
				
				//if in water turn on fog
				
				if(isUnderWater(xpos, -camHieght+0.5f, zpos)==50){
					fogNear=2;
					fogFar=	18;
					GL11.glFog(GL11.GL_FOG_COLOR, fogColoursWater);
					GL11.glFogf(GL11.GL_FOG_START, fogNear);
			        GL11.glFogf(GL11.GL_FOG_END, fogFar);
					//inWater=true;
				}else{
					fogNear=72;
					fogFar=	180;	
					GL11.glFog(GL11.GL_FOG_COLOR, fogColours);
				    GL11.glFogf(GL11.GL_FOG_START, fogNear);
			        GL11.glFogf(GL11.GL_FOG_END, fogFar);
					//inWater = false;
				}
				
				if(isUnderWater(xpos, playerheight+1, zpos)==50){
					
					//GL11.glEnable(GL11.GL_FOG);
					inWater=true;
					runBoost=0;
				}else{
					//GL11.glDisable(GL11.GL_FOG);
					
					
					inWater = false;
				}
				
				
				
				if(lastInwater!=inWater){
					
					if(lastInwater && !inWater){
						
					}else{
						yVelocity=yVelocity/3;
						Sound.water1.play();
					}
				
				}
				
				lastInwater= inWater;
				getFace((int)xpos);
				//getNormalisedCamVector();
				//RayPick();
		
			//--------------------------------------------------------------------------
			
			if(keyOClicked && !broken){
			//	System.out.println("block breaker=" + breakerBlockStep);
				breakerCounter++;
				if(breakerCounter>1)breakerBlockStep++;  //  >1  was %10
				if(breakerBlockStep==9){
					removeBlock();
					breakerCounter=0;
					breakerBlockStep=0;
					broken=true;
					keyOClicked=false;
				}
				
				
			}
			
			updateEntities();
			f+=0.0002f;
			if(f>0.0625)f=0f;
			updateFPS(); // update FPS Counter
			tick++;
			if(tick==64)tick=0;
		
			
		
			
	//		lastChunk = curentCunk=getCurrentCunk();
		}
		
		public void getNormalisedCamVector(){
			camVector.y =  (float) Math.sin(lookupdown * piover180) * 1f;
			float v = (float) Math.cos(lookupdown * piover180) * 1f;
			camVector.x = (float) Math.sin(yrot * piover180) * v;
			camVector.z= (float) Math.cos(yrot * piover180) * v;
			
		}
		
		public void getFace(int start){
			getNormalisedCamVector();
			XDist=1000;
			YDist=1000;
			ZDist=1000;
			
			float xx = 0;
			float xy = 0;
			float xz = 0;
			float zx = 0;
			float zy = 0;
			float zz = 0;
			float yx = 0;
			float yy = 0;
			float yz = 0;
			
			helperFace=70;
			float t = 0;
			
			
			//do right X sweep
			if(camVector.x>0){
				
				for(int distance=1;distance<10;distance++){
				//solve for t
				t =   (((int)xpos -( distance+0.5f) )-xpos) / camVector.x;
				Xh = (int)xpos -(distance + 1);
				
				//solve for Yh
				Yh = -camHieght + t*camVector.y;
				Zh = zpos + t  * camVector.z;
				Xd = xpos - Xh;
				Yd = Math.abs(-camHieght - Yh);
				Zd =Math.abs(zpos - Zh);
				
				
				Yh = (int) (Yh+0.5f);
				Zh = (int)( Zh+0.5f);
				helperX=Xh;
				helperY=Yh;
				helperZ=Zh;
				//System.out.println("Xh="+Xh+ "   Yh="+ Yh +  "  Zh=" + Zh);
				if(isHelperOnSoildBlock()){
					helperFace = 5;
					
					XDist = (float)Math.sqrt(Xd*Xd + Yd* Yd + Zd*Zd);
					xx = Xh; xy = Yh; xz = Zh;
					//System.out.println("XDist =" + XDist );
					break;
				}
				}
				
			}
			
			//do left X sweep
			if(camVector.x<0){
				
				for(int distance=1;distance<10;distance++){
				//solve for t
				t =   (((int)xpos +( distance-0.5f) )-xpos) / camVector.x;
				Xh = (int)xpos + (distance );
				
				//solve for Yh
				Yh = -camHieght + t*camVector.y;
				Zh = zpos + t  * camVector.z;
				Xd = xpos - Xh;
				Yd = Math.abs(-camHieght - Yh);
				Zd =Math.abs(zpos - Zh);
				
				
				Yh = (int) (Yh+0.5f);
				Zh = (int)( Zh+0.5f);
				helperX=Xh;
				helperY=Yh;
				helperZ=Zh;
				//System.out.println("Xh="+Xh+ "   Yh="+ Yh +  "  Zh=" + Zh);
				if(isHelperOnSoildBlock()){
					
					
					XDist = (float)Math.sqrt(Xd*Xd + Yd* Yd + Zd*Zd);
					xx = Xh; xy = Yh; xz = Zh;
					//System.out.println("XDist =" + XDist );
					break;
				}
				}
				
			}
			
			
			
			//do right Z sweep
			if(camVector.z>0){
				
				for(int distance=1;distance<10;distance++){
				//solve for t
				t =   (((int)zpos -( distance+0.5f) )-zpos) / camVector.z;
				Zh = (int)zpos -(distance + 1);
				
				//solve for Yh and Xh
				Yh = -camHieght + t*camVector.y;
				Xh = xpos + t  * camVector.x;
				
					LastXd = Xh;
					LastYd = Yh;
					LastZd = Zh+0.5f;
				
				Zd = zpos - Zh;
				Yd = Math.abs(-camHieght - Yh);
				Xd = Math.abs(xpos -Xh);
				
				
				
				
				Yh = (int) (Yh+0.5f);
				Xh = (int)( Xh+0.5f);
				helperX=Xh;
				helperY=Yh;
				helperZ=Zh;
				
				
				//System.out.println("Xh="+Xh+ "   Yh="+ Yh +  "  Zh=" + Zh);
				if(isHelperOnSoildBlock()){
					
					
					ZDist = (float)Math.sqrt(Xd*Xd + Yd* Yd + Zd*Zd);
					
					//if (YDist<XDist)helperFace = 6;
					//System.out.println("YDist =" + YDist );
					zx = Xh;zy = Yh;zz = Zh;
					
					break;
				}
				}
				
			}
			
			//do left Z sweep
			if(camVector.z<0){
				
				for(int distance=1;distance<10;distance++){
				//solve for t
				t =   (((int)zpos +( distance-0.5f) )-zpos) / camVector.z;
				Zh = (int)zpos +(distance);
				
				//solve for Yh and Xh
				Yh = -camHieght + t*camVector.y;
				Xh = xpos + t  * camVector.x;
				
					LastXd = Xh;
					LastYd = Yh;
					LastZd = Zh+0.5f;
				
				Zd = zpos - Zh;
				Yd = Math.abs(-camHieght - Yh);
				Xd = Math.abs(xpos -Xh);
				
				
				
				
				Yh = (int) (Yh+0.5f);
				Xh = (int)( Xh+0.5f);
				helperX=Xh;
				helperY=Yh;
				helperZ=Zh;
				
				
				//System.out.println("Xh="+Xh+ "   Yh="+ Yh +  "  Zh=" + Zh);
				if(isHelperOnSoildBlock()){
					
					
					ZDist = (float)Math.sqrt(Xd*Xd + Yd* Yd + Zd*Zd);
					
					//if (YDist<XDist)helperFace = 6;
					//System.out.println("YDist =" + YDist );
					zx = Xh;zy = Yh;zz = Zh;
					
					break;
				}
				}
				
			}
			
			
			
			//do right Y sweep
			if(camVector.y>0){
			//	System.out.println("Y vector=" + camVector.y);
				for(int distance=1;distance<10;distance++){
				//solve for t
				t =   (((int)-camHieght -( distance+0.5f) )+camHieght) / camVector.y;
				Yh = (int)-camHieght -(distance + 1);
				
				//solve for Yh and Xh
				Zh = zpos + t  * camVector.z;
				Xh = xpos + t  * camVector.x;
				
//					LastXd = Xh;
//					LastYd = Yh;
//					LastZd = Zh+0.5f;
				
				Zd = Math.abs(zpos -Zh);
				Yd = Math.abs(-camHieght - Yh);
				Xd = Math.abs(xpos -Xh);
				
				
				
				
				Zh = (int) (Zh+0.5f);
				Xh = (int)( Xh+0.5f);
				helperX=Xh;
				helperY=Yh;
				helperZ=Zh;
				
				
				//System.out.println("Xh="+Xh+ "   Yh="+ Yh +  "  Zh=" + Zh);
				if(isHelperOnSoildBlock()){
					
					
					YDist = (float)Math.sqrt(Xd*Xd + Yd* Yd + Zd*Zd);
					
					//if (YDist<XDist)helperFace = 6;
					System.out.println("YDist =" + YDist );
					yx = Xh;yy = Yh;yz = Zh;
					
					break;
				}
				}
				
			}
			
			
			
			//do up Y sweep
			if(camVector.y<0){
			//	System.out.println("Y vector=" + camVector.y);
				for(int distance=1;distance<10;distance++){
				//solve for t
				t =   (((int)-camHieght +( distance-0.5f) )+camHieght) / camVector.y;
				Yh = (int)-camHieght +(distance );
				
				//solve for Yh and Xh
				Zh = zpos + t  * camVector.z;
				Xh = xpos + t  * camVector.x;
				
//					LastXd = Xh;
//					LastYd = Yh;
//					LastZd = Zh+0.5f;
				
				Zd = Math.abs(zpos -Zh);
				Yd = Math.abs(-camHieght - Yh);
				Xd = Math.abs(xpos -Xh);
				
				
				
				
				Zh = (int) (Zh+0.5f);
				Xh = (int)( Xh+0.5f);
				helperX=Xh;
				helperY=Yh;
				helperZ=Zh;
				
				
				//System.out.println("Xh="+Xh+ "   Yh="+ Yh +  "  Zh=" + Zh);
				if(isHelperOnSoildBlock()){
					
					
					YDist = (float)Math.sqrt(Xd*Xd + Yd* Yd + Zd*Zd);
					
					//if (YDist<XDist)helperFace = 6;
					System.out.println("YDist =" + YDist );
					yx = Xh;yy = Yh;yz = Zh;
					
					break;
				}
				}
				
			}
		

			if (ZDist < XDist && ZDist < YDist){
				
				if(camVector.z>0){
				helperFace = 6;
				}else{
				helperFace = 3;	
				}
				Xh = zx; Yh = zy; Zh=zz;
			} 
			if (XDist < ZDist && XDist < YDist){
			
				if(camVector.x>0){
				helperFace = 5;	
				}else{
				helperFace = 4;	
				}
				
				
				Xh = xx; Yh = xy; Zh=xz;
			}
			if (YDist < ZDist && YDist < XDist){
			
				if(camVector.y>0){
				helperFace = 7;
				}else{
				helperFace = 8;
				}
				Xh = yx; Yh = yy; Zh=yz;
				//Xh = helperX; Yh = helperY; Zh=helperZ;
				
			}
			
		helperX=Xh;
		helperY=Yh;
		helperZ=Zh;
		
		}
		
		
		public void RayPick(){
			
			//helperFace=20;
			//update the helper --------------------------------------------------------
			for(int h=0; h<helpers.length;h++){
				//int h=80;
				helpers[h].y = -camHieght -  addYVector(h*0.1f);
				float v = (float) Math.cos(lookupdown * piover180) * (h*0.1f);
				helpers[h].x = addXVector(v);
				helpers[h].z = addZVector(v);
				
				if(areHelpersOnSoildBlock(helpers[h])){
					helperX=helpers[h].x;
					helperY=helpers[h].y;
					helperZ=helpers[h].z;
					//getFace(h);
					break;
				}
				helperCounter++;
			}
			
		
//			//set it back to just normal
		//	helperX = addXVector(6);
		//	helperZ = addZVector(6);
		//	helperY = -camHieght - addYVector(6);	
			
		}

		public void updateEntities(){
			for(Entity Ent : entities){
				
				ground = getGroundLevel(Ent.getX(), Ent.getY(), Ent.getZ());
				
			
			
			 	Ent.setY((float) (Ent.getY()+Ent.getyVel()*TIME_STEP*2));
				Ent.setYVel( Ent.getyVel() +((float) (GRAVITY*TIME_STEP)));
			
				if(Ent.getY()<=ground+0.7f)	{
					Ent.setYVel(-(Ent.getyVel()/4));
					
					Ent.setY(ground+0.7f);
					Ent.sethVelocity(Ent.gethVelocity()/1.8f);
					
				}	
				
				Ent.setX(Ent.getX() + ((float) Math.sin(Ent.getyRot() * piover180) * Ent.gethVelocity()));
				Ent.setZ(Ent.getZ() + ((float) Math.cos(Ent.getyRot() * piover180) * Ent.gethVelocity()));
				
			
				
			Ent.tick();
			
			if(xpos<Ent.getX()+1 && xpos>Ent.getX()-1){
				if(zpos<Ent.getZ()+1 && zpos>Ent.getZ()-1){
						Ent.setAlive(false);//remove entities
						Sound.collect.play();
						inventory.addItem(Ent.getBlockID(), 1);
				}
			}
			
			
			
			}
			
			for(int i=0;i<entities.size();i++){
				if(!entities.get(i).isAlive())entities.remove(i);
			}
			
			
		}

		/***************************************************************************************************************************************************************************************************
		 * Checks if key is pressed or mouse is moved etc.
		 **************************************************************************************************************************************************************************************************/
		private void checkInput() {
			
			

			if (Keyboard.next() && Keyboard.getEventKeyState()) {
				
				if (Keyboard.getEventKey() == Keyboard.KEY_ESCAPE)
					closeRequested = true;
			}
				Keyboard.poll(); // Update keyboard's state
				
			
				
				if (Keyboard.isKeyDown(Keyboard.KEY_E)) { //Right
				//gui=true;
					
				}
				

				if (Keyboard.isKeyDown(Keyboard.KEY_R)) { //Right
					gui=false;
					WorkbenchGui = false;
					Mouse.setCursorPosition(512, 400);
					SetCursorInVisable();
					hideCursor=true;
				}
				
//				if(gui){
//					Mouse.setCursorPosition(512, 400);
//					return;
//					
//				}
				
				
				if(!hideCursor){
					//Mouse.setCursorPosition(512, 400);
					return;
					
				}
				
				
				if (Keyboard.isKeyDown(Keyboard.KEY_RIGHT)||Keyboard.isKeyDown(Keyboard.KEY_D)) { //Right
					//this is going to be the same as the forward but with  collison
					//xpos -= (float) Math.sin(yrot * piover180) * 0.1f;
					//zpos += (float) Math.cos(yrot * piover180) * 0.1f;
					
					CamX= xpos;
					CamY=-camHieght;
					CamZ= zpos;
					InX = LastXd;
					InY= LastYd;
					InZ = LastZd;
				}

				if (Keyboard.isKeyDown(Keyboard.KEY_LEFT)||Keyboard.isKeyDown(Keyboard.KEY_A)) { // Left
					//yrot += 1.0f; // Rotate The Scene To The Right
					//xpos += (float) Math.sin(yrot * piover180) * 0.1f;
					//zpos -= (float) Math.cos(yrot * piover180) * 0.1f;
				}

//				if (Keyboard.isKeyDown(Keyboard.KEY_R)) { // 
//					lookupdown -= 1.0f; // Rotate The Scene Downwards
//				}
	//
//				if (Keyboard.isKeyDown(Keyboard.KEY_F)) { // 
//					lookupdown += 1.0f; // Rotate The Scene Upwards
//				}
				
				if (Keyboard.getEventKey() == Keyboard.KEY_1) {
				    if (Keyboard.getEventKeyState()) {
				     if(!key1Clicked)
				    	// placeBlock((int)itemNum);
				    	 itemNum+=1;
				     System.out.println("Item ID = " + itemNum);
				     if(itemNum>13)itemNum=1;
				      key1Clicked=true;
				    }
				    else {
				     key1Clicked= false;
				    }
				}
				
				
				
				if (Keyboard.getEventKey() == Keyboard.KEY_2) { // 
					  if (Keyboard.getEventKeyState()) {
						     if(!key2Clicked)
						    	 itemNum-=1;
						     if(itemNum<1)itemNum=9;
						      key2Clicked=true;
						    }
						    else {
						    	
						     key2Clicked= false;
						    }
				}
				
				//helper
				if (Keyboard.getEventKey() == Keyboard.KEY_P) { // 
					 if (Keyboard.getEventKeyState()) {
					     if(!keyPClicked)
					    	 placeBlock((int)itemNum);
					    	 keyPClicked=true;
					    }
					    else {
					     keyPClicked= false;
					    }
				}
//				if (Keyboard.getEventKey() == Keyboard.KEY_O) { // 
//					 if (Keyboard.getEventKeyState()) {
//					     if(!keyOClicked)
//					    	 if(isHelperOnSoildBlock()){
//					    	// removeBlock();
//					    	 keyOClicked=true;
//					     		breaking=true;
//					    	 }
//					    }
//					    else {
//					     keyOClicked= false;
//					     breakerBlockStep=0;
//					     breakerCounter=0;
//					     breaking=false;
//					     broken=false;
//					    }
//				}
				if (Keyboard.isKeyDown(Keyboard.KEY_K)) { // 
					helperZ-=0.1f;
				}
				if (Keyboard.isKeyDown(Keyboard.KEY_L)) { // 
					helperZ+=0.1f;
				}
				if (Keyboard.isKeyDown(Keyboard.KEY_U)) { // 
					helperX+=0.1f;
				}
				if (Keyboard.isKeyDown(Keyboard.KEY_J)) { // 
					helperX-=0.1f;
				}
				if (Keyboard.isKeyDown(Keyboard.KEY_Y)) { // 
					helperY+=0.1f;
				}
				if (Keyboard.isKeyDown(Keyboard.KEY_H)) { // 
					helperY-=0.1f;
				}
				
				if (Keyboard.isKeyDown(Keyboard.KEY_M)) { // 
					
					running=true;
					runBoost=0.2f;
					runningCountdown=128;
//					for(int c = 0; c<9;c++){
//					writeChunk(c);
//					}
				}
				
				if (Keyboard.isKeyDown(Keyboard.KEY_N)) { // 
					for(int c = 0; c<9;c++){
						readChunk(c);
						}
				}
				
				if (Keyboard.isKeyDown(Keyboard.KEY_SPACE)) { // Jump not implimented proprly
					
					if(!isJumping){
						isJumping= true;
						yVelocity=6f;
						//playerheight+=4.0f; // move up  --- then fall down!
					}
				}
				
				if (Keyboard.isKeyDown(Keyboard.KEY_Z)) { // 
					yVelocity=3.5f;
					}
				
				
				
				if (Keyboard.isKeyDown(Keyboard.KEY_UP)||Keyboard.isKeyDown(Keyboard.KEY_W)) { // Up Arrow...
					
					
					//basic collison  0.3f is used as a temp fix for char width
					if(!isBlock(xpos - (float) Math.sin(yrot * piover180) * 0.35f,zpos - (float) Math.cos(yrot * piover180) * 0.35f)){
						
					//this will cause some errors when walking out of the chunk
					if(inWater){
						runBoost=0;
						runningCountdown=0;
					xpos -= (float) Math.sin(yrot * piover180) * (0.15f+swimspeed);
					zpos -= (float) Math.cos(yrot * piover180) * (0.15f+swimspeed);	
						
					}else{
						
					
					xpos -= (float) Math.sin(yrot * piover180) * (0.15f+runBoost);
					zpos -= (float) Math.cos(yrot * piover180) * (0.15f+runBoost);	
				
					}
					
					
					
					walkbiasangle += 10.0f;

					if (walkbiasangle > 360.0f) {
						walkbiasangle -= 360.0f;
					}

					walkbias = (float) Math.sin(walkbiasangle * piover180) / 20.0f;
					
					}
				}

				if (Keyboard.isKeyDown(Keyboard.KEY_DOWN)||Keyboard.isKeyDown(Keyboard.KEY_S)) { // Down Arrow...
					xpos += (float) Math.sin(yrot * piover180) * 0.1f;
					zpos += (float) Math.cos(yrot * piover180) * 0.1f;

					walkbiasangle -= 10.0f;

					if (walkbiasangle < 0.0f) {
						walkbiasangle += 360.0f;
					}
					
					// bob while walking
					walkbias = (float) Math.sin(walkbiasangle * piover180) / 20.0f;
				}

				helperVisible=false;
				
				
				
			if(Mouse.isButtonDown(0)){			
						
						if(isHelperOnSoildBlock()){
							//removeBlock();
			    		keyOClicked=true;
			     		breaking=true;
			     		//System.out.println("Clicked");
						}
			    }	 else {
			    	 keyOClicked= false;
				     breakerBlockStep=0;
				     breakerCounter=0;
				     breaking=false;
				     broken=false;

			    }
				
			if(Mouse.isButtonDown(1)){	
				if(isHelperOnSoildBlock()){
					if(HelperBlockID()==31){
						if(placeBlockTimer==0){
						gui=true;
						WorkbenchGui=true;
						hideCursor=false;
						SetCursorVisable();
						}
					}	else{
					if(placeBlockTimer==0) placeBlock((int)itemNum);
				}
			}
			}
			
				
				    int dWheel = Mouse.getDWheel();
				    if (dWheel < 0) {

				    	
				        inventory.currentSelectionINC();
				    } else if (dWheel > 0){
				    	inventory.currentSelectionDec();
				    }
			
			
			
			
				if(Mouse.getX()>mouseLastX){
					int temp = Mouse.getX() - mouseLastX;
					yrot -= 0.2f * temp;
					Mouse.setCursorPosition(512, Mouse.getY());
				}
				if(Mouse.getX()<mouseLastX){
					int temp = mouseLastX - Mouse.getX() ;
					yrot += 0.2f * temp;
					Mouse.setCursorPosition(512, Mouse.getY());
				}
				
				
			
				if(Mouse.getY()>mouseLastY){
					int temp = Mouse.getY() - mouseLastY;
					lookupdown -= 0.15f * temp;
					Mouse.setCursorPosition(512, 400);
				}
				if(Mouse.getY()<mouseLastY){
					int temp = mouseLastY - Mouse.getY() ;
					lookupdown += 0.15f * temp;
					Mouse.setCursorPosition(512, 400);
				}
		
			
				mouseLastX=Mouse.getX();
				mouseLastY=Mouse.getY();
				
				//Mouse.setCursorPosition(512, 400);
				
			//}
			
		
			//shut down game if close is pressed
			if (Display.isCloseRequested()) {
				closeRequested = true;
			}
				
			
		}

		/**
		 * Accepts Float world x,z position.
		 * y position is determined by player height.
		 * 
		 * @param xp World X position
		 * @param zp World Z position
		 * @return
		 * Returns a boolean true if the block is soild and walkable.
		 * Plants,Water and Air return false.
		 */
				
		private boolean isBlock(float xp, float zp) {  
						
			//convert to block units
			int x=(int)(xp+0.5);
			int z=(int)(zp+0.5);
				
			//get the chunk of the block		
			Point p = getChunk(x, z); 
			 
			//this will find the block within the chunk
			x=x%16; 
			z=z%16;
					
			
			if(chunks[p.getX()][p.getY()].getblockID(x, (int)playerheight+1,z)>49)return false;			
			if(chunks[p.getX()][p.getY()].getblockID(x, (int)playerheight+1,z)==0)return false;
			
			//block is solid
			return true;
		}
		
		/**
		 * Accepts Float world x,y,z position.		 
		 * 
		 * @param xp World X position
		 * @param yP World Y position
		 * @param zp World Z position
		 * @return
		 * a boolean true if the block is soild.
		 * Plants,Water and Air return false.
		 */
		
		private boolean isBlockGeneral(float xp,float yP, float zp) {  
			//convert to block units
			int x=(int)(xp+0.5);
			int z=(int)(zp+0.5);
				
			//get the chunk of the block		
			Point p = getChunk(x, z); 
			 
			//this will find the block within the chunk
			x=x%16; 
			z=z%16;
			
			
			
			if(chunks[p.getX()][p.getY()].getblockID(x, (int)yP,z)>49)return false;
		
			if(chunks[p.getX()][p.getY()].getblockID(x, (int)yP,z)==0)return false;
			return true;
		}
		
		
		/**
		 * 
		 * @return
		 * True if the helper is on a Solid block.
		 * Water, Plants, and Air return false.
		 *
		 */
		private boolean isHelperOnSoildBlock() {
			
			
			// conver to block units
			int Hx = (int)(0.5+helperX);
			int Hz =(int)(0.5+helperZ);
			int Hy =(int)(0.5+helperY);
					
			if(Hy<0) return false;
			if(Hz<0) return false;
			if(Hx<0) return false;
					//System.out.println("Helper Hz =  " + Hz);
			Point p = getChunk(Hx, Hz);
			
			if(Hz>=16) Hz=Hz%16;
			if(Hx>=16) Hx=Hx%16;
			
			//get the block ID
			int bID =  chunks[p.getX()][p.getY()].getblockID(Hx, Hy, Hz);
			
			
			if(bID == 0)return false;
			if(bID >49)return false;
			
			
			return true;
					
				
		}
		
		/**
		 * 
		 * @return
		 * The ID value of the block that the helper is on.
		 */
		private int HelperBlockID() {  
			// check if block
					int Hx = (int)(0.5+helperX);
					int Hz =(int)(0.5+helperZ);
					int Hy =(int)(0.5+helperY);
					//System.out.println("Hx =  " + Hx);
					//System.out.println("Hz =  " +  Hz);
					if(Hy<0) return 0;
					if(Hx<0) return 0;
					if(Hz<0) return 0;
					
								
					Point p = getChunk(Hx, Hz);
						
					if(Hz>=16) Hz=Hz%16;
					if(Hx>=16) Hx=Hx%16;
					
					return chunks[p.getX()][p.getY()].getblockID(Hx, Hy, Hz);
					
					
				
		}
		
		/**
		 * 
		 * @param HelpersVec
		 * @return
		 */
		private boolean areHelpersOnSoildBlock(Vector3f HelpersVec) {  
			// check if block
			
					int Hx = (int)(0.5+HelpersVec.x);
					int Hz =(int)(0.5+HelpersVec.z);
					int Hy =(int)(0.5+HelpersVec.y);
					//System.out.println("Hx =  " + Hx);
					//System.out.println("Hz =  " +  Hz);
					if(Hy<0) return false;
					if(Hx<0) return false;
					if(Hz<0) return false;
													
					Point p = getChunk(Hx, Hz);
				
					if(Hz>=16) Hz=Hz%16;
					if(Hx>=16) Hx=Hx%16;
					
					//get the block ID
					int bID =  chunks[p.getX()][p.getY()].getblockID(Hx, Hy, Hz);
					
					helperOnBlock=false;
					if(bID == 0)return false;
					if(bID > 49)return false;
					
					
					helperOnBlock=true;
					return true;
					
		}
		
		
		
		
	
		
	
		/**
		 * 
		 * @param xp
		 * @param yp
		 * @param zp
		 * @return Integer of the ground level under the location x,z
		 * under height y
		 */
		private int getGroundLevel(float xp,float yp, float zp) {  
			
			int x = (int)(xp+0.5);  //convert to block units
			int z = (int)(zp+0.5);
			
			
			Point p = getChunk(x, z);
			
			int y = (int)yp;
			
			x=x%16; //this will find the block withing the chunk 
			z=z%16;
				
			int groundLevel=y;	
			for(int gl = groundLevel;y>-1;y--){ //cycle thorugh the blocks under the player untill we hit one;
			
				if(chunks[p.getX()][p.getY()].isblockSolid(x, gl,z))return gl;
			}
			return 0;
		}
		
		
		/**
		 * 
		 * @param xp
		 * @param yp
		 * @param zp
		 * @return
		 * the block ID. If it is 3 it is water.
		 */
		private int isUnderWater(float xp,float yp, float zp) {  
			
			 xp = (int)(xp+0.5);  //convert to block units
			 zp = (int)(zp+0.5);
			
			Point p = getChunk(xp, zp);
			
			xp=xp%16; //this will find the block withing the chunk (even with negative blocks)
			zp=zp%16;
				
			return chunks[p.getX()][p.getY()].getblockID((int)xp, (int)yp, (int)zp);
		}



		private void placeBlock(int item) {
			
			
			
			// check if block
			int Hx = (int)(0.5+helperX);
			int Hz =(int)(0.5+helperZ);
			int Hy =(int)(0.5+helperY);
			
			//modify for face picking
			if(helperFace==5)Hx+=1;
			if(helperFace==4)Hx-=1;
			if(helperFace==6)Hz+=1;
			if(helperFace==3)Hz-=1;
			if(helperFace==7)Hy+=1;
			if(helperFace==8)Hy-=1;
			
			
			if(Hy<0) return;
			if(Hz<0) return;
			if(Hx<0) return;
			
			Point p = getChunk(Hx, Hz);
				
			if(Hz>=16) Hz=Hz%16;
			if(Hx>=16) Hx=Hx%16;
			inventory.takeItem();
			chunks[p.getX()][p.getY()].setblockID(Hx, Hy, Hz,(byte)item);
			
			placeBlockTimer=1;
			if(item>50){ //needs modifying for water placement
				chunks[p.getX()][p.getY()].buildTransparentVertexData();
			}else{
				chunks[p.getX()][p.getY()].buildVertexData();
			}
		
		}
		
		private void removeBlock() {
			// check if block
			int Hx = (int)(0.5+helperX);
			int Hz =(int)(0.5+helperZ);
			int Hy =(int)(0.5+helperY);
			
			
			Point p = getChunk(Hx, Hz);
	
			if(Hz>=16) Hz=Hz%16;
			if(Hx>=16) Hx=Hx%16;
			
			Sound.dig1.play(); //to add more sounds Ie --- Sound.playBlock(bi); let the sound class work it out
			
			//bi = block ID
			int bi = chunks[p.getX()][p.getY()].getblockID(Hx, Hy, Hz);
			entities.add(new EntityBlock(helperX, helperY, helperZ,3,bi));	
			
			
			chunks[p.getX()][p.getY()].setblockID(Hx, Hy, Hz,(byte)0);
			
			//if the block is transparnet update the transparent display list
			if(bi >50){
				chunks[p.getX()][p.getY()].buildTransparentVertexData();
				}else{
				chunks[p.getX()][p.getY()].buildVertexData();
				}
			
			
		}


		/***************************************************************************************************************************************************************************************************
		 * Deinitialization and clean up.
		 **************************************************************************************************************************************************************************************************/
		private void deInit() {
			//shut everything down
		
		
		
			glDeleteProgram(shaderProgram);
	        glDeleteShader(vertexShader);
	        glDeleteShader(fragmentShader);

			Keyboard.destroy();
			Display.destroy();
		}
		
		
		/***************************************************************************************************************************************************************************************************
		 * Constructor (Mainloop)
		 **************************************************************************************************************************************************************************************************/
		public Main() {

			init(); //set up
			getDelta(); // call once before loop to initialise lastFrame
			lastFPS = getTime(); // call before loop to initialise fps timer
		
			VisableCursor = Mouse.getNativeCursor();
			
			//set up the cursor
			try {
				emptyCursor = new org.lwjgl.input.Cursor(1, 1, 0, 0, 1, BufferUtils.createIntBuffer(1), null);
				Mouse.setNativeCursor(emptyCursor);
			} catch (LWJGLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			
			mouseLastY =  Mouse.getY();
			mouseLastX =  Mouse.getX();
			yrot = 0;
			
			while (!closeRequested) {
				
				int delta = getDelta();
				
				
				checkInput();	
				
				updateLogic();  
			
				render();
				
				Display.update();
				


			}
			deInit();  //shut everything down
		}
		
		
		/** 
		 * Calculate how many milliseconds have passed 
		 * since last frame.
		 * 
		 * @return milliseconds passed since last frame 
		 */
		public int getDelta() {
		    long time = getTime();
		    int delta = (int) (time - lastFrame);
		    lastFrame = time;
		 
		    return delta;
		}
		
		/**
		 * Get the accurate system time
		 * 
		 * @return The system time in milliseconds
		 */
		public long getTime() {
		    return (Sys.getTime() * 1000) / Sys.getTimerResolution();
		}
		
		/**
		 * Calculate the FPS and set it in the title bar
		 */
		public void updateFPS() {
			if (getTime() - lastFPS > 1000) {
				Display.setTitle("3d Game v.0.1    FPS: " + fps   );
				fps = 0;
				lastFPS += 1000;
			} 
			fps++;
		}
		

		
		/**
		 * @param 
		 *Float x in the world position
		 * @param
		 *Float y in the world position
		 * @return Returns the Chunk X,Y position in the Array in the form of A Point
		 */
		
		public Point getChunk(float x, float z){
			
		x  = (int) (x/16);
		z =  (int) (z/16);
			
		for (int yC = 0; yC < mapWidth; yC++) {
			for (int xC = 0; xC < mapWidth; xC++) {

				if (chunks[xC][yC].getXindex() == x
						&& chunks[xC][yC].getZindex() == z) {

					return new Point(xC, yC);
				}
			}
		}
			
			return new Point (0,0);
		}

		
		

		/***************************************************************************************************************************************************************************************************
		 * Main entrance
		 **************************************************************************************************************************************************************************************************/
		public static void main(String[] args) {

			new Main();
		}
		
		private void enterOrtho() {
			 GL11.glDisable(GL11.GL_DEPTH_TEST);

			 // Load the projection mode and save it's current state
			 GL11.glMatrixMode(GL11.GL_PROJECTION); 
			GL11.glPushMatrix();
			 GL11.glLoadIdentity();
			
			 // Set up orthographic projection mode
			 GL11.glOrtho(0, 1024, 800,0, -1, 1);
			// GL11.glOrtho(left, right, bottom, top, zNear, zFar)

			 // Enter model view mode
			 GL11.glMatrixMode(GL11.GL_MODELVIEW);
			 GL11.glPushMatrix();
			 GL11.glLoadIdentity();
			 }
		
		private void leaveOrtho() {
			 // Restore the state of the projection mode
			 GL11.glMatrixMode(GL11.GL_PROJECTION);
			 GL11.glPopMatrix();

			 // Restore the state of the model view mode
			 GL11.glMatrixMode(GL11.GL_MODELVIEW);
			 GL11.glPopMatrix();
			 GL11.glEnable(GL11.GL_DEPTH_TEST);
			 }
		
		private void chunkLoader(){
			File testFile = new File("res/level.txt");
			String string = new String("");
			
			try {
				ReadWriteTextFile.setContents(testFile, string);
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			int i = 0;
			
			//parse string
			for(int y = 0; y<16;y++){
				for(int x = 0; x<16;x++){
					for(int z = 0; z<16;z++){
					
					
				//		chunks[0].setblockID(x,y, z,(byte)Integer.parseInt(string, i));
						i++;
					}
					
				}
				string= string + "\n";
			}
			
		}
		
		private void chunkSaver(){
			File testFile = new File("res/level.txt");
			String string = new String("Chunk=0    X=0    y=0"+ "\n");
			
			for(int y = 0; y<16;y++){
				for(int x = 0; x<16;x++){
					for(int z = 0; z<16;z++){
					
					
		//				string = string + chunks[0].getblockID(x,y, z);
					}
					
				}
				string= string + "\n";
			}
			
			try {
				ReadWriteTextFile.setContents(testFile, string);
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}

		public void writeChunk (int chunkNumber){
			
			
			
			byte[][][] writeChunk = new byte[16][16][16];
			
			//write the data into a temp array
			for (int xC = 0; xC < 16; xC++) {
				for (int zC = 0; zC < 16; zC++) {			
					for (int yC = 0; yC < 16; yC++) {
					
			//			writeChunk[xC][yC][zC] = (byte) chunks[chunkNumber].getblockID(xC, yC, zC);
									
					}
				}
			}
			
			//output file
			String file = new String(chunks[chunkNumber][0].getName()+".dat");
			try {
				ObjectOutputStream objOut = new ObjectOutputStream( new FileOutputStream(file));
				objOut.writeObject(writeChunk);
				objOut.close();
			} catch (Exception e) {
				
			e.printStackTrace();
			}
			
			//System.out.println("Written chunk "+ file);
			
		}
		
		
	public void readChunk (int chunkNumber){
			
			byte[][][] readChunk = new byte[16][16][16];
			
			
			
			//inputfile file
			String file = new String(chunks[chunkNumber][0].getName()+".dat");
			try {
				
				FileInputStream fileIn = new FileInputStream(file);
				ObjectInputStream in = new ObjectInputStream(fileIn);
				readChunk = (byte[][][])in.readObject();
				in.close();
				fileIn.close();
			
			} catch (Exception e) {
				
				e.printStackTrace();
			}
			
			//write the data into a temp array
			for (int xC = 0; xC < 16; xC++) {
				for (int zC = 0; zC < 16; zC++) {			
					for (int yC = 0; yC < 16; yC++) {
					
			//		 chunks[chunkNumber].setblockID(xC, yC, zC, readChunk[xC][yC][zC]);
									
					}
				}
			}
			//System.out.println("Opened chunk "+ file);
			
		}
		

	private void draw2dLine(Point point, Point point2) {
	    GL11.glColor3f(0.0f, 1.0f, 0.2f);
	    GL11.glBegin(GL11.GL_LINE_STRIP);

	    GL11.glVertex2d(point.getX(), point.getY());
	    GL11.glVertex2d(point2.getX(), point2.getY());
	    GL11.glEnd();
	}

	private void draw3dLine(float x1, float x2,float y1,float y2 ,float z1,float z2) {
	    GL11.glColor3f(1.0f, 1.0f, 1.0f);
	    
	    GL11.glBegin(GL11.GL_LINE_STRIP);
	   
	    GL11.glVertex3f(x1, y1, z1);
	    GL11.glVertex3f(x2, y2, z2);
	    
	    
	    GL11.glEnd();
	}

	public float addXVector (float amount){
		return xpos - (float) Math.sin(yrot * piover180) * amount; //amount is Hypotanuse
	}

	public float addZVector (float amount){
		return zpos - (float) Math.cos(yrot * piover180) * amount;
	}

	public float addYVector (float amount){
		return (float) Math.sin(lookupdown * piover180) * amount;
	}

	public float getCamVector(float step){
		
		return (float)(Math.cos(lookupdown)*step);
		
	}

	public float getHelperY(float step){
		//System.out.println("helpery = " + (float)(Math.sin(lookupdown* piover180)*step));
		return (float)(Math.sin(lookupdown* piover180)*step);
		
	}

	static void preRender() {
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT
				| GL_STENCIL_BUFFER_BIT);
		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
	}




	

	
	/**
	 * Resets the glIdentity and the camera rotation
	 * and transformations to the player position.
	 */
	public void CamReset(){
		GL11.glLoadIdentity();
		GL11.glRotatef(lookupdown, 1.0f, 0, 0);
		GL11.glRotatef(360.0f - yrot, 0, 1.0f, 0);
		GL11.glTranslatef(-xpos, camHieght , -zpos);
	}

	


	public static int createVBOID() {
		  if (GLContext.getCapabilities().GL_ARB_vertex_buffer_object) {
		    IntBuffer buffer = BufferUtils.createIntBuffer(1);
		    ARBVertexBufferObject.glGenBuffersARB(buffer);
		    return buffer.get(0);
		  }
		  return 0;
		}


	
	/**
	 * 
	 * @return the currnet Chunk number
	 */
	public int getCurrentCunk(){
		//this is wrong now
		return (int)((xpos+0.5f)/16f) +   ((int)((zpos+0.5f)/16f)*8);
	}
	
		
	    public void SetCursorVisable(){
	    	try {
				
				Mouse.setNativeCursor(VisableCursor);
			} catch (LWJGLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    }
	    
	    public void SetCursorInVisable(){
	    	try {
				
				Mouse.setNativeCursor(emptyCursor);
			} catch (LWJGLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	    	
	    }
	    

//		public void  NorthRowGenerator(){
//			int currentZcunk=(int)((zpos+0.5f)/16f);
//			
//			for(int a = 0;a<8;a++){ //generate a whole row of 8 chunks
//			
//				
//			int i=chunkZ+4;
//			
//			if(i>7)i-=8;
//			
//			i=(i*8)	+ a; //convert to linear
//			//System.out.println("i=" + i);
//			chunks[i].clearArray();
//			chunks[i].setStartX(a);
//			chunks[i].setStartZ(currentZcunk+4);
//			
//			if (a == 0) {// if the chunk is on the end x=0
//				// chunks[i].DiamondCunk(nw, ne, sw, se);
//				if (i == 0) {
//					//chunks[i].DiamondCunk(0, 0, 0, 0); //the first chunk
//					chunks[i].DiamondCunk(0,0,chunks[56].getHeight(15, 15),chunks[56].getHeight(0,15));
//					//System.out.println("chunk56= "+chunks[56].getHeight(0,15) );
//					
//				}else{
//					chunks[i].DiamondCunk(0,0,chunks[i-8].getHeight(15, 15),chunks[i-8].getHeight(0,15));
//				}
//				
//				
//			}
//			
//			
//			
//			if(a>0){//if the chunk is not on the end x=0
//			//chunks[i].DiamondCunk(nw, ne, sw, se);
//				if (i >8 ) {
//					chunks[i].DiamondCunk(0,chunks[i-1].getHeight(15, 15),chunks[i-8].getHeight(15, 15),chunks[i-1].getHeight(15, 0));
//				}else{
//					//chunks[i].DiamondCunk(0,chunks[i-1].getHeight(15, 15),0,chunks[i-1].getHeight(15, 0));
//					chunks[i].DiamondCunk(0,chunks[i-1].getHeight(15, 15),chunks[56+a].getHeight(15, 15),chunks[i-1].getHeight(15, 0));
//				}
//
//			}
//			
//			bufferChunks(chunks[i]);
//			}
//			
//			
//		//	System.out.println("Generated North row  "); 
//		}

}
