package window;

import java.util.ArrayList;

import org.lwjgl.util.Point;

import privatives.Quad;
import privatives.TexturedQuad;

public class bagWindow extends baseWindow{
	
	//TexturedQuad quad = new TexturedQuad();
	float spacing = 0.125f;
	int itemSize=64;
	public final int bagSize = 10;
	public int currnetSelection = 0;
	public int[][] slots = new int[10][2]; //first number is slot contens (block ID) second is quantity.
	public int stackSize = 64+1;
	public Point temp = new Point(0,0);

	public bagWindow(String name, int x, int y, int width, int height) {
		super(name, x, y, width, height);
		this.barHeight=48;
		for(int i = 0;i<bagSize;i++){
			slots[i][0]=0;
			
			}
	}
	
	/**
	 * Adds an item of blockID to the bag if possible.
	 * 
	 * @param ItemID
	 * @return True if item added, false if it could not be.
	 */
	public boolean addItem(int ItemID, int Quantity){
		
		//first scan to see if that item exists already
		for(int i = 0;i<bagSize;i++){
			if (slots[i][0]==ItemID){
				if(slots[i][1]+Quantity<stackSize){
					slots[i][1]=slots[i][1]+Quantity;
					return true;
				}
			}
		}
		
		
		//next scan to see if there is a space free
		for(int i = 0;i<bagSize;i++){
			if (slots[i][0]==0){
				slots[i][0]=ItemID;
				slots[i][1]=Quantity;
				return true;
			}
		}
		
		
		return false;
	}
	
	
	public void takeItem(){
		slots[currnetSelection][1]=slots[currnetSelection][1]-1;
		if(slots[currnetSelection][1]==0){
			slots[currnetSelection][0]=0;
		}
	}
	
	public void RenderBag(){
		if(!visable)return;
		super.Render();
		
		
		for(int a = 0;a<5;a++){
			for(int d = 0;d<2;d++){
				
				if(currnetSelection%5 == a  && currnetSelection/5 == d){
					TexturedQuad.render(3, x+4+(a*itemSize), y+barHeight+2+(d*itemSize), itemSize,itemSize, spacing, spacing*0, spacing*2);	
				}else{
				TexturedQuad.render(3, x+4+(a*itemSize), y+barHeight+2+(d*itemSize), itemSize,itemSize, spacing, spacing*0, spacing*0);
				}
				
			}
		}
		
		
		for(int i = 0;i<bagSize;i++){
			if(slots[i][0]>0){
				temp = getItemPos(slots[i][0]);
				TexturedQuad.render(3, x+4+((i%5)*itemSize), y+barHeight+2+((i/5)*itemSize), itemSize,itemSize, spacing, temp.getX()*spacing, spacing*temp.getY());
				GameFont.drawString( "" + slots[i][1] ,  x+10+((i%5)*itemSize),y+barHeight+50+((i/5)*itemSize),barHeight/4);	
			}
		}
		
		
		
	}
	
	public int getCurrentItmeNum(){
		return slots[currnetSelection][0];
	}
	
	public void currentSelectionINC(){
		currnetSelection++;
		if(currnetSelection>=bagSize)currnetSelection=0;
	}
	
	public void currentSelectionDec(){
		currnetSelection--;
		if(currnetSelection<0)currnetSelection=bagSize-1;
	}
	
	public Point getItemPos(int ID){
		
		if(ID==1)return new Point (1,0); // soil
		if(ID==2)return new Point (2,0); // soil
		if(ID==3)return new Point (3,0); // soil
		if(ID==4)return new Point (4,0); // soil
		if(ID==5)return new Point (5,0); // soil
		if(ID==6)return new Point (6,0); // soil
		if(ID==7)return new Point (7,0); // soil
		if(ID==8)return new Point (0,1); // soil
		
		
		if(ID==30)return new Point (1,1); // soil
		if(ID==31)return new Point (2,1); // soil
		if(ID==60)return new Point (5,1); // soil
		if(ID==61)return new Point (6,1); // soil
		
		return new Point (0,0);
	}

}
